using System;
using System.Collections;
using System.Collections.Generic;
using System.Linq;
using UnityEngine;
using UnityEngine.Events;

namespace Mod
{
    internal class HaltSyringe : OldSyringeBehaviour
    {
        public override Type GetPoisonType()
        {
            return typeof(HaltPoison);
        }
    }

    internal class SpeedSyringe : OldSyringeBehaviour
    {
        public override Type GetPoisonType()
        {
            return typeof(SpeedPoison);
        }
    }

    internal class FlowSyringe : OldSyringeBehaviour
    {
        public override Type GetPoisonType()
        {
            return typeof(FlowPoison);
        }
    }

    internal class AgendaSyringe : OldSyringeBehaviour
    {
        public override Type GetPoisonType()
        {
            return typeof(AgendaPoison);
        }
    }

    internal class AureusSyringe : OldSyringeBehaviour
    {
        public override Type GetPoisonType()
        {
            return typeof(AureusPoison);
        }
    }

    internal class AntipodeaSyringe : OldSyringeBehaviour
    {
        public override Type GetPoisonType()
        {
            return typeof(AntipodePoison);
        }
    }

    internal class InfernateSyringe : OldSyringeBehaviour
    {
        public override Type GetPoisonType()
        {
            return typeof(InfernatePoison);
        }
    }

    internal class LotusSyringe : OldSyringeBehaviour
    {
        public override Type GetPoisonType()
        {
            return typeof(LotusPoison);
        }
    }

    internal class PurainSyringe : OldSyringeBehaviour
    {
        public override Type GetPoisonType()
        {
            return typeof(PurainPoison);
        }
    }

    internal class PuzzlrSyringe : OldSyringeBehaviour
    {
        public override Type GetPoisonType()
        {
            return typeof(PuzzlrPoison);
        }
    }

    internal class ReversionSyringe : OldSyringeBehaviour
    {
        public override Type GetPoisonType()
        {
            return typeof(ReversionPoison);
        }
    }

    internal class TensionSyringe : OldSyringeBehaviour
    {
        public override Type GetPoisonType()
        {
            return typeof(TensionPoison);
        }
    }

    internal class TranceSyringe : OldSyringeBehaviour
    {
        public override Type GetPoisonType()
        {
            return typeof(TrancePoison);
        }
    }

    internal class ShadeSyringe : OldSyringeBehaviour
    {
        public override Type GetPoisonType()
        {
            return typeof(ShadePoison);
        }
    }

    internal class PenumbrateSyringe : OldSyringeBehaviour
    {
        public override Type GetPoisonType()
        {
            return typeof(PenumbratePoison);
        }
    }

    internal class ErasureSyringe : OldSyringeBehaviour
    {
        public override Type GetPoisonType()
        {
            return typeof(ErasurePoison);
        }
    }

    internal class GlimpseSyringe : OldSyringeBehaviour
    {
        public override Type GetPoisonType()
        {
            return typeof(GlimpsePoison);
        }
    }

    internal class SnapSyringe : OldSyringeBehaviour
    {
        public override Type GetPoisonType()
        {
            return typeof(SnapPoison);
        }
    }

    public class HaltPoison : PoisonSpreadBehaviour
    {
        public LimbBehaviour limb;

        public override float SpreadSpeed
        {
            get
            {
                return 55;
            }
        }

        public override float Lifespan
        {
            get
            {
                return 1;
            }
        }

        public override void Start()
        {
            PhysicalBehaviour physicalBehaviour = this.Limb.PhysicalBehaviour;
            GameObject Instance = physicalBehaviour.GetComponent<LimbBehaviour>().Person.gameObject;
            PersonBehaviour person = physicalBehaviour.GetComponent<LimbBehaviour>().Person;

            if (!person.Limbs[11].gameObject.GetComponent<Halt>())
            {
                person.Limbs[11].gameObject.AddComponent<Halt>();
            }
            
            if (!person.Limbs[13].gameObject.GetComponent<Halt>())
            {
                person.Limbs[13].gameObject.AddComponent<Halt>();
            }
        }
    }
    public class SnapPoison : PoisonSpreadBehaviour
    {
        public LimbBehaviour limb;

        public override float SpreadSpeed
        {
            get
            {
                return 55;
            }
        }

        public override float Lifespan
        {
            get
            {
                return 1;
            }
        }

        public override void Start()
        {
            PhysicalBehaviour physicalBehaviour = this.Limb.PhysicalBehaviour;
            GameObject Instance = physicalBehaviour.GetComponent<LimbBehaviour>().Person.gameObject;
            PersonBehaviour person = physicalBehaviour.GetComponent<LimbBehaviour>().Person;

            if (!person.Limbs[11].gameObject.GetComponent<Snap>())
            {
                person.Limbs[11].gameObject.AddComponent<Snap>();
            }
            
            if (!person.Limbs[13].gameObject.GetComponent<Snap>())
            {
                person.Limbs[13].gameObject.AddComponent<Snap>();
            }
        }
    }
    public class SpeedPoison : PoisonSpreadBehaviour
    {
        public LimbBehaviour limb;

        public override float SpreadSpeed
        {
            get
            {
                return 55;
            }
        }

        public override float Lifespan
        {
            get
            {
                return 1;
            }
        }

        public override void Start()
        {
            PhysicalBehaviour physicalBehaviour = this.Limb.PhysicalBehaviour;
            GameObject Instance = physicalBehaviour.GetComponent<LimbBehaviour>().Person.gameObject;
            PersonBehaviour person = physicalBehaviour.GetComponent<LimbBehaviour>().Person;

            if (!person.Limbs[11].gameObject.GetComponent<Speed>())
            {
                person.Limbs[11].gameObject.AddComponent<Speed>();
            }
            
            if (!person.Limbs[13].gameObject.GetComponent<Speed>())
            {
                person.Limbs[13].gameObject.AddComponent<Speed>();
            }
        }
    }
    public class FlowPoison : PoisonSpreadBehaviour
    {
        public LimbBehaviour limb;

        public override float SpreadSpeed
        {
            get
            {
                return 55;
            }
        }

        public override float Lifespan
        {
            get
            {
                return 1;
            }
        }

        public override void Start()
        {
            PhysicalBehaviour physicalBehaviour = this.Limb.PhysicalBehaviour;
            GameObject Instance = physicalBehaviour.GetComponent<LimbBehaviour>().Person.gameObject;
            PersonBehaviour person = physicalBehaviour.GetComponent<LimbBehaviour>().Person;

            foreach (var Limbs in person.Limbs)
                        {
                            if (!Limbs.gameObject.GetComponent<q>())
            {
                Limbs.gameObject.AddComponent<q>();
            }
                        }

            if (!person.Limbs[0].gameObject.GetComponent<Flow>())
            {
                person.Limbs[0].gameObject.AddComponent<Flow>();
            }
        }
    }
    public class AureusPoison : PoisonSpreadBehaviour
    {
        public LimbBehaviour limb;

        public override float SpreadSpeed
        {
            get
            {
                return 55;
            }
        }

        public override float Lifespan
        {
            get
            {
                return 1;
            }
        }

        public override void Start()
        {
            PhysicalBehaviour physicalBehaviour = this.Limb.PhysicalBehaviour;
            GameObject Instance = physicalBehaviour.GetComponent<LimbBehaviour>().Person.gameObject;
            PersonBehaviour person = physicalBehaviour.GetComponent<LimbBehaviour>().Person;

            foreach (var Limbs in person.Limbs)
                        {
                            if (!Limbs.gameObject.GetComponent<q>())
            {
                Limbs.gameObject.AddComponent<q>();
            }
                        }

            if (!person.Limbs[0].gameObject.GetComponent<Aureus>())
            {
                person.Limbs[0].gameObject.AddComponent<Aureus>();
            }
        }
    }
    public class ReversionPoison : PoisonSpreadBehaviour
    {
        public LimbBehaviour limb;

        public override float SpreadSpeed
        {
            get
            {
                return 55;
            }
        }

        public override float Lifespan
        {
            get
            {
                return 1;
            }
        }

        public override void Start()
        {
            PhysicalBehaviour physicalBehaviour = this.Limb.PhysicalBehaviour;
            GameObject Instance = physicalBehaviour.GetComponent<LimbBehaviour>().Person.gameObject;
            PersonBehaviour person = physicalBehaviour.GetComponent<LimbBehaviour>().Person;

            foreach (var Limbs in person.Limbs)
                        {
                            if (!Limbs.gameObject.GetComponent<q>())
            {
                Limbs.gameObject.AddComponent<q>();
            }
                        }

            if (!person.Limbs[11].gameObject.GetComponent<Reversion>())
            {
                person.Limbs[11].gameObject.AddComponent<Reversion>();
                person.Limbs[11].gameObject.GetComponent<Reversion>().arm1 = person.Limbs[11].gameObject;
                person.Limbs[11].gameObject.GetComponent<Reversion>().arm2 = person.Limbs[13].gameObject;
            }
        }
    }
    public class TensionPoison : PoisonSpreadBehaviour
    {
        public LimbBehaviour limb;

        public override float SpreadSpeed
        {
            get
            {
                return 55;
            }
        }

        public override float Lifespan
        {
            get
            {
                return 1;
            }
        }

        public override void Start()
        {
            PhysicalBehaviour physicalBehaviour = this.Limb.PhysicalBehaviour;
            GameObject Instance = physicalBehaviour.GetComponent<LimbBehaviour>().Person.gameObject;
            PersonBehaviour person = physicalBehaviour.GetComponent<LimbBehaviour>().Person;

            if (!person.Limbs[0].gameObject.GetComponent<Tension>())
            {
                person.Limbs[0].gameObject.AddComponent<Tension>();
            }
        }
    }
    public class PuzzlrPoison : PoisonSpreadBehaviour
    {
        public LimbBehaviour limb;

        public override float SpreadSpeed
        {
            get
            {
                return 55;
            }
        }

        public override float Lifespan
        {
            get
            {
                return 1;
            }
        }

        public override void Start()
        {
            PhysicalBehaviour physicalBehaviour = this.Limb.PhysicalBehaviour;
            GameObject Instance = physicalBehaviour.GetComponent<LimbBehaviour>().Person.gameObject;
            PersonBehaviour person = physicalBehaviour.GetComponent<LimbBehaviour>().Person;


                if (!person.Limbs[11].gameObject.GetComponent<h>())
            {
                person.Limbs[11].gameObject.AddComponent<h>();
                person.Limbs[11].gameObject.AddComponent<UseEventTrigger>().Action = () =>
                {
                    GameObject Projectile = GameObject.Instantiate(ModAPI.FindSpawnable("puzzlrpiece").Prefab);
                    CatalogBehaviour.PerformMod(ModAPI.FindSpawnable("puzzlrpiece"), Projectile);
                    Projectile.transform.rotation = person.Limbs[11].gameObject.transform.rotation;
                    Projectile.transform.eulerAngles += new Vector3(0, 0, 180);
                    Projectile.transform.position = person.Limbs[11].gameObject.transform.position + (-person.Limbs[11].gameObject.transform.up * 0.5f);
                    Projectile.GetComponent<Rigidbody2D>().AddRelativeForce(Projectile.transform.up * 466);
                };
            }

                if (!person.Limbs[13].gameObject.GetComponent<h>())
            {
                person.Limbs[13].gameObject.AddComponent<h>();
                person.Limbs[13].gameObject.AddComponent<UseEventTrigger>().Action = () =>
                {
                    GameObject Projectile = GameObject.Instantiate(ModAPI.FindSpawnable("puzzlrpiece").Prefab);
                    CatalogBehaviour.PerformMod(ModAPI.FindSpawnable("puzzlrpiece"), Projectile);
                    Projectile.transform.rotation = person.Limbs[13].gameObject.transform.rotation;
                    Projectile.transform.eulerAngles += new Vector3(0, 0, 180);
                    Projectile.transform.position = person.Limbs[13].gameObject.transform.position + (-person.Limbs[13].gameObject.transform.up * 0.5f);
                    Projectile.GetComponent<Rigidbody2D>().AddRelativeForce(Projectile.transform.up * 466);
                };
            }
        }
    }
    public class LotusPoison : PoisonSpreadBehaviour
    {
        public LimbBehaviour limb;

        public override float SpreadSpeed
        {
            get
            {
                return 55;
            }
        }

        public override float Lifespan
        {
            get
            {
                return 1;
            }
        }

        public override void Start()
        {
            PhysicalBehaviour physicalBehaviour = this.Limb.PhysicalBehaviour;
            GameObject Instance = physicalBehaviour.GetComponent<LimbBehaviour>().Person.gameObject;
            PersonBehaviour person = physicalBehaviour.GetComponent<LimbBehaviour>().Person;

            if (!person.Limbs[11].gameObject.GetComponent<Lotus>())
            {
                person.Limbs[11].gameObject.AddComponent<Lotus>();
            }
            
            if (!person.Limbs[13].gameObject.GetComponent<Lotus>())
            {
                person.Limbs[13].gameObject.AddComponent<Lotus>();
            }
        }
    }
    public class AntipodePoison : PoisonSpreadBehaviour
    {
        public LimbBehaviour limb;

        public override float SpreadSpeed
        {
            get
            {
                return 55;
            }
        }

        public override float Lifespan
        {
            get
            {
                return 1;
            }
        }

        public override void Start()
        {
            PhysicalBehaviour physicalBehaviour = this.Limb.PhysicalBehaviour;
            GameObject Instance = physicalBehaviour.GetComponent<LimbBehaviour>().Person.gameObject;
            PersonBehaviour person = physicalBehaviour.GetComponent<LimbBehaviour>().Person;

            foreach (var Limbs in person.Limbs)
                        {
                            if (!Limbs.gameObject.GetComponent<q>())
            {
                Limbs.gameObject.AddComponent<q>();
            }
                        }

            if (!person.Limbs[0].gameObject.GetComponent<Antipode>())
            {
                person.Limbs[0].gameObject.AddComponent<Antipode>();
            }
        }
    }
    public class AgendaPoison : PoisonSpreadBehaviour
    {
        public LimbBehaviour limb;

        public override float SpreadSpeed
        {
            get
            {
                return 55;
            }
        }

        public override float Lifespan
        {
            get
            {
                return 1;
            }
        }

        public override void Start()
        {
            PhysicalBehaviour physicalBehaviour = this.Limb.PhysicalBehaviour;
            GameObject Instance = physicalBehaviour.GetComponent<LimbBehaviour>().Person.gameObject;
            PersonBehaviour person = physicalBehaviour.GetComponent<LimbBehaviour>().Person;


               if (!person.Limbs[11].gameObject.GetComponent<h>())
            {
                person.Limbs[11].gameObject.AddComponent<h>();
                person.Limbs[11].gameObject.AddComponent<UseEventTrigger>().Action = () =>
                {
                    GameObject Projectile = GameObject.Instantiate(ModAPI.FindSpawnable("agendacard").Prefab);
                    CatalogBehaviour.PerformMod(ModAPI.FindSpawnable("agendacard"), Projectile);
                    Projectile.transform.rotation = person.Limbs[11].gameObject.transform.rotation;
                    Projectile.transform.eulerAngles += new Vector3(0, 0, 180);
                    Projectile.transform.position = person.Limbs[11].gameObject.transform.position + (-person.Limbs[11].gameObject.transform.up * 0.5f);
                    Projectile.GetComponent<Rigidbody2D>().AddRelativeForce(Projectile.transform.up * 46);
                };
            }

                if (!person.Limbs[13].gameObject.GetComponent<h>())
            {
                person.Limbs[13].gameObject.AddComponent<h>();
                person.Limbs[13].gameObject.AddComponent<UseEventTrigger>().Action = () =>
                {
                    GameObject Projectile = GameObject.Instantiate(ModAPI.FindSpawnable("agendacard").Prefab);
                    CatalogBehaviour.PerformMod(ModAPI.FindSpawnable("agendacard"), Projectile);
                    Projectile.transform.rotation = person.Limbs[13].gameObject.transform.rotation;
                    Projectile.transform.eulerAngles += new Vector3(0, 0, 180);
                    Projectile.transform.position = person.Limbs[13].gameObject.transform.position + (-person.Limbs[13].gameObject.transform.up * 0.5f);
                    Projectile.GetComponent<Rigidbody2D>().AddRelativeForce(Projectile.transform.up * 46);
                };
            }
        }
    }
    public class PurainPoison : PoisonSpreadBehaviour
    {
        public LimbBehaviour limb;

        public override float SpreadSpeed
        {
            get
            {
                return 55;
            }
        }

        public override float Lifespan
        {
            get
            {
                return 1;
            }
        }

        public override void Start()
        {
            PhysicalBehaviour physicalBehaviour = this.Limb.PhysicalBehaviour;
            GameObject Instance = physicalBehaviour.GetComponent<LimbBehaviour>().Person.gameObject;
            PersonBehaviour person = physicalBehaviour.GetComponent<LimbBehaviour>().Person;

            if (!person.Limbs[11].gameObject.GetComponent<Water>())
            {
                person.Limbs[11].gameObject.AddComponent<Water>();
                person.Limbs[11].gameObject.GetComponent<Water>().armthing = person.Limbs[13].gameObject;
                person.Limbs[11].gameObject.GetComponent<Water>().mrkrinkle = person.Limbs[11].gameObject;
            }
        }
    }
    public class InfernatePoison : PoisonSpreadBehaviour
    {
        public LimbBehaviour limb;

        public override float SpreadSpeed
        {
            get
            {
                return 55;
            }
        }

        public override float Lifespan
        {
            get
            {
                return 1;
            }
        }

        public override void Start()
        {
            PhysicalBehaviour physicalBehaviour = this.Limb.PhysicalBehaviour;
            GameObject Instance = physicalBehaviour.GetComponent<LimbBehaviour>().Person.gameObject;
            PersonBehaviour person = physicalBehaviour.GetComponent<LimbBehaviour>().Person;

            if (!person.Limbs[11].gameObject.GetComponent<Fire>())
            {
                person.Limbs[11].gameObject.AddComponent<Fire>();
                person.Limbs[11].gameObject.GetComponent<Fire>().armthing = person.Limbs[13].gameObject;
                person.Limbs[11].gameObject.GetComponent<Fire>().mrkrinkle = person.Limbs[11].gameObject;
            }
        }
    }
    public class TrancePoison : PoisonSpreadBehaviour
    {
        public LimbBehaviour limb;

        public override float SpreadSpeed
        {
            get
            {
                return 55;
            }
        }

        public override float Lifespan
        {
            get
            {
                return 1;
            }
        }

        public override void Start()
        {
            PhysicalBehaviour physicalBehaviour = this.Limb.PhysicalBehaviour;
            GameObject Instance = physicalBehaviour.GetComponent<LimbBehaviour>().Person.gameObject;
            PersonBehaviour person = physicalBehaviour.GetComponent<LimbBehaviour>().Person;

            if (!person.Limbs[0].gameObject.GetComponent<Trance>())
            {
                person.Limbs[0].gameObject.AddComponent<Trance>();
            }
        }
    }
    public class ShadePoison : PoisonSpreadBehaviour
    {
        public LimbBehaviour limb;

        public override float SpreadSpeed
        {
            get
            {
                return 55;
            }
        }

        public override float Lifespan
        {
            get
            {
                return 1;
            }
        }

        public override void Start()
        {
            PhysicalBehaviour physicalBehaviour = this.Limb.PhysicalBehaviour;
            GameObject Instance = physicalBehaviour.GetComponent<LimbBehaviour>().Person.gameObject;
            PersonBehaviour person = physicalBehaviour.GetComponent<LimbBehaviour>().Person;

            if (!person.Limbs[0].gameObject.GetComponent<Shade>())
            {
                person.Limbs[0].gameObject.AddComponent<Shade>();
            }
        }
    }
    public class PenumbratePoison : PoisonSpreadBehaviour
    {
        public LimbBehaviour limb;

        public override float SpreadSpeed
        {
            get
            {
                return 55;
            }
        }

        public override float Lifespan
        {
            get
            {
                return 1;
            }
        }

        public override void Start()
        {
            PhysicalBehaviour physicalBehaviour = this.Limb.PhysicalBehaviour;
            GameObject Instance = physicalBehaviour.GetComponent<LimbBehaviour>().Person.gameObject;
            PersonBehaviour person = physicalBehaviour.GetComponent<LimbBehaviour>().Person;

            if (!person.Limbs[0].gameObject.GetComponent<Penumbrate>())
            {
                person.Limbs[0].gameObject.AddComponent<Penumbrate>();
            }
        }
    }
    public class ErasurePoison : PoisonSpreadBehaviour
    {
        public LimbBehaviour limb;

        public override float SpreadSpeed
        {
            get
            {
                return 55;
            }
        }

        public override float Lifespan
        {
            get
            {
                return 1;
            }
        }

        public override void Start()
        {
            PhysicalBehaviour physicalBehaviour = this.Limb.PhysicalBehaviour;
            GameObject Instance = physicalBehaviour.GetComponent<LimbBehaviour>().Person.gameObject;
            PersonBehaviour person = physicalBehaviour.GetComponent<LimbBehaviour>().Person;

            if (!person.Limbs[0].gameObject.GetComponent<Erasure>())
            {
                person.Limbs[0].gameObject.AddComponent<Erasure>();
            }
        }
    }
    public class GlimpsePoison : PoisonSpreadBehaviour
    {
        public LimbBehaviour limb;

        public override float SpreadSpeed
        {
            get
            {
                return 55;
            }
        }

        public override float Lifespan
        {
            get
            {
                return 1;
            }
        }

        public override void Start()
        {
            PhysicalBehaviour physicalBehaviour = this.Limb.PhysicalBehaviour;
            GameObject Instance = physicalBehaviour.GetComponent<LimbBehaviour>().Person.gameObject;
            PersonBehaviour person = physicalBehaviour.GetComponent<LimbBehaviour>().Person;

            if (!person.Limbs[0].gameObject.GetComponent<Glimpse>())
            {
                person.Limbs[0].gameObject.AddComponent<Glimpse>();
            }
        }
    }
}    