using System.Collections;
using System;
using UnityEngine;
using System.Linq;
using System.Collections.Generic;
using Random=UnityEngine.Random;
using UnityEngine.Events;

namespace Mod
{
    public class Mod
    {

        public static string ModTag = "<color=#7809b5>ZSH <color=white>";

        public static void Main()
        {
            CategoryBuilder.Create("Zuccians SuperHumans", "super duper", ModAPI.LoadSprite("logo_category.png"));

            ModAPI.Register(
    new Modification()
    {
        OriginalItem = ModAPI.FindSpawnable("Empty Syringe"), //item to derive from
        NameOverride = ModTag + "Halt Syringe", //new item name with a suffix to assure it is globally unique
        DescriptionOverride = "Gives the user the ability of Halt", //new item description
        CategoryOverride = ModAPI.FindCategory("Zuccians SuperHumans"), //new item category
        ThumbnailOverride = ModAPI.LoadSprite("suringe.png"), //new item thumbnail (relative path)
        AfterSpawn = (Instance) => //all code in the AfterSpawn delegate will be executed when the item is spawned
        {
             
            Instance.AddComponent<HaltSyringe>();
            Instance.GetComponent<SpriteRenderer>().color = new Color32(100, 100, 150, 255);
        }
    }
);

ModAPI.Register(
    new Modification()
    {
        OriginalItem = ModAPI.FindSpawnable("Empty Syringe"), //item to derive from
        NameOverride = ModTag + "Speed Syringe", //new item name with a suffix to assure it is globally unique
        DescriptionOverride = "Gives the user the ability of Speed", //new item description
        CategoryOverride = ModAPI.FindCategory("Zuccians SuperHumans"), //new item category
        ThumbnailOverride = ModAPI.LoadSprite("suringe.png"), //new item thumbnail (relative path)
        AfterSpawn = (Instance) => //all code in the AfterSpawn delegate will be executed when the item is spawned
        {
             
            Instance.AddComponent<SpeedSyringe>();
            Instance.GetComponent<SpriteRenderer>().color = new Color32(100, 100, 250, 255);
        }
    }
);

ModAPI.Register(
    new Modification()
    {
        OriginalItem = ModAPI.FindSpawnable("Empty Syringe"), //item to derive from
        NameOverride = ModTag + "Flow Syringe", //new item name with a suffix to assure it is globally unique
        DescriptionOverride = "Gives the user the ability of Flow", //new item description
        CategoryOverride = ModAPI.FindCategory("Zuccians SuperHumans"), //new item category
        ThumbnailOverride = ModAPI.LoadSprite("suringe.png"), //new item thumbnail (relative path)
        AfterSpawn = (Instance) => //all code in the AfterSpawn delegate will be executed when the item is spawned
        {
             
            Instance.AddComponent<FlowSyringe>();
            Instance.GetComponent<SpriteRenderer>().color = new Color32(255, 0, 15, 255);
        }
    }
);
ModAPI.Register(
    new Modification()
    {
        OriginalItem = ModAPI.FindSpawnable("Empty Syringe"), //item to derive from
        NameOverride = ModTag + "Agenda Syringe", //new item name with a suffix to assure it is globally unique
        DescriptionOverride = "Gives the user the ability of Agenda", //new item description
        CategoryOverride = ModAPI.FindCategory("Zuccians SuperHumans"), //new item category
        ThumbnailOverride = ModAPI.LoadSprite("suringe.png"), //new item thumbnail (relative path)
        AfterSpawn = (Instance) => //all code in the AfterSpawn delegate will be executed when the item is spawned
        {
             
            Instance.AddComponent<AgendaSyringe>();
            Instance.GetComponent<SpriteRenderer>().color = new Color32(150, 100, 100, 255);
        }
    }
);
ModAPI.Register(
    new Modification()
    {
        OriginalItem = ModAPI.FindSpawnable("Empty Syringe"), //item to derive from
        NameOverride = ModTag + "Antipode Syringe", //new item name with a suffix to assure it is globally unique
        DescriptionOverride = "Gives the user the ability of Antipode", //new item description
        CategoryOverride = ModAPI.FindCategory("Zuccians SuperHumans"), //new item category
        ThumbnailOverride = ModAPI.LoadSprite("suringe.png"), //new item thumbnail (relative path)
        AfterSpawn = (Instance) => //all code in the AfterSpawn delegate will be executed when the item is spawned
        {
             
            Instance.AddComponent<AntipodeaSyringe>();
            Instance.GetComponent<SpriteRenderer>().color = new Color32(150, 50, 255, 255);
        }
    }
);
ModAPI.Register(
    new Modification()
    {
        OriginalItem = ModAPI.FindSpawnable("Empty Syringe"), //item to derive from
        NameOverride = ModTag + "Aureus Syringe", //new item name with a suffix to assure it is globally unique
        DescriptionOverride = "Gives the user the ability of Aureus", //new item description
        CategoryOverride = ModAPI.FindCategory("Zuccians SuperHumans"), //new item category
        ThumbnailOverride = ModAPI.LoadSprite("suringe.png"), //new item thumbnail (relative path)
        AfterSpawn = (Instance) => //all code in the AfterSpawn delegate will be executed when the item is spawned
        {
             
            Instance.AddComponent<AureusSyringe>();
            Instance.GetComponent<SpriteRenderer>().color = new Color32(150, 0, 200, 255);
        }
    }
);
ModAPI.Register(
    new Modification()
    {
        OriginalItem = ModAPI.FindSpawnable("Empty Syringe"), //item to derive from
        NameOverride = ModTag + "Infernate Syringe", //new item name with a suffix to assure it is globally unique
        DescriptionOverride = "Gives the user the ability of Infernate", //new item description
        CategoryOverride = ModAPI.FindCategory("Zuccians SuperHumans"), //new item category
        ThumbnailOverride = ModAPI.LoadSprite("suringe.png"), //new item thumbnail (relative path)
        AfterSpawn = (Instance) => //all code in the AfterSpawn delegate will be executed when the item is spawned
        {
             
            Instance.AddComponent<InfernateSyringe>();
            Instance.GetComponent<SpriteRenderer>().color = new Color32(150, 0, 0, 255);
        }
    }
);
ModAPI.Register(
    new Modification()
    {
        OriginalItem = ModAPI.FindSpawnable("Empty Syringe"), //item to derive from
        NameOverride = ModTag + "Lotus Syringe", //new item name with a suffix to assure it is globally unique
        DescriptionOverride = "Gives the user the ability of Lotus", //new item description
        CategoryOverride = ModAPI.FindCategory("Zuccians SuperHumans"), //new item category
        ThumbnailOverride = ModAPI.LoadSprite("suringe.png"), //new item thumbnail (relative path)
        AfterSpawn = (Instance) => //all code in the AfterSpawn delegate will be executed when the item is spawned
        {
             
            Instance.AddComponent<LotusSyringe>();
            Instance.GetComponent<SpriteRenderer>().color = new Color32(25, 150, 0, 255);
        }
    }
);
ModAPI.Register(
    new Modification()
    {
        OriginalItem = ModAPI.FindSpawnable("Empty Syringe"), //item to derive from
        NameOverride = ModTag + "Purain Syringe", //new item name with a suffix to assure it is globally unique
        DescriptionOverride = "Gives the user the ability of Purain", //new item description
        CategoryOverride = ModAPI.FindCategory("Zuccians SuperHumans"), //new item category
        ThumbnailOverride = ModAPI.LoadSprite("suringe.png"), //new item thumbnail (relative path)
        AfterSpawn = (Instance) => //all code in the AfterSpawn delegate will be executed when the item is spawned
        {
             
            Instance.AddComponent<PurainSyringe>();
            Instance.GetComponent<SpriteRenderer>().color = new Color32(0, 150, 150, 255);
        }
    }
);
ModAPI.Register(
    new Modification()
    {
        OriginalItem = ModAPI.FindSpawnable("Empty Syringe"), //item to derive from
        NameOverride = ModTag + "Puzzlr Syringe", //new item name with a suffix to assure it is globally unique
        DescriptionOverride = "Gives the user the ability of Puzzlr", //new item description
        CategoryOverride = ModAPI.FindCategory("Zuccians SuperHumans"), //new item category
        ThumbnailOverride = ModAPI.LoadSprite("suringe.png"), //new item thumbnail (relative path)
        AfterSpawn = (Instance) => //all code in the AfterSpawn delegate will be executed when the item is spawned
        {
             
            Instance.AddComponent<PuzzlrSyringe>();
            Instance.GetComponent<SpriteRenderer>().color = new Color32(150, 0, 200, 255);
        }
    }
);
ModAPI.Register(
    new Modification()
    {
        OriginalItem = ModAPI.FindSpawnable("Empty Syringe"), //item to derive from
        NameOverride = ModTag + "Reversion Syringe", //new item name with a suffix to assure it is globally unique
        DescriptionOverride = "Gives the user the ability of Reversion", //new item description
        CategoryOverride = ModAPI.FindCategory("Zuccians SuperHumans"), //new item category
        ThumbnailOverride = ModAPI.LoadSprite("suringe.png"), //new item thumbnail (relative path)
        AfterSpawn = (Instance) => //all code in the AfterSpawn delegate will be executed when the item is spawned
        {
             
            Instance.AddComponent<ReversionSyringe>();
            Instance.GetComponent<SpriteRenderer>().color = new Color32(150, 100, 200, 255);
        }
    }
);
ModAPI.Register(
    new Modification()
    {
        OriginalItem = ModAPI.FindSpawnable("Empty Syringe"), //item to derive from
        NameOverride = ModTag + "Tension Syringe", //new item name with a suffix to assure it is globally unique
        DescriptionOverride = "Gives the user the ability of Tension", //new item description
        CategoryOverride = ModAPI.FindCategory("Zuccians SuperHumans"), //new item category
        ThumbnailOverride = ModAPI.LoadSprite("suringe.png"), //new item thumbnail (relative path)
        AfterSpawn = (Instance) => //all code in the AfterSpawn delegate will be executed when the item is spawned
        {
             
            Instance.AddComponent<TensionSyringe>();
            Instance.GetComponent<SpriteRenderer>().color = new Color32(150, 150, 100, 255);
        }
    }
);
ModAPI.Register(
    new Modification()
    {
        OriginalItem = ModAPI.FindSpawnable("Empty Syringe"), //item to derive from
        NameOverride = ModTag + "Trance Syringe", //new item name with a suffix to assure it is globally unique
        DescriptionOverride = "Gives the user the ability of Trance", //new item description
        CategoryOverride = ModAPI.FindCategory("Zuccians SuperHumans"), //new item category
        ThumbnailOverride = ModAPI.LoadSprite("suringe.png"), //new item thumbnail (relative path)
        AfterSpawn = (Instance) => //all code in the AfterSpawn delegate will be executed when the item is spawned
        {
             
            Instance.AddComponent<TranceSyringe>();
            Instance.GetComponent<SpriteRenderer>().color = new Color32(50, 150, 150, 255);
        }
    }
);

ModAPI.Register(
    new Modification()
    {
        OriginalItem = ModAPI.FindSpawnable("Empty Syringe"), //item to derive from
        NameOverride = ModTag + "Shade Syringe", //new item name with a suffix to assure it is globally unique
        DescriptionOverride = "Gives the user the ability of Shade", //new item description
        CategoryOverride = ModAPI.FindCategory("Zuccians SuperHumans"), //new item category
        ThumbnailOverride = ModAPI.LoadSprite("suringe.png"), //new item thumbnail (relative path)
        AfterSpawn = (Instance) => //all code in the AfterSpawn delegate will be executed when the item is spawned
        {
             
            Instance.AddComponent<ShadeSyringe>();
            Instance.GetComponent<SpriteRenderer>().color = new Color32(150, 0, 25, 255);
        }
    }
);

ModAPI.Register(
    new Modification()
    {
        OriginalItem = ModAPI.FindSpawnable("Empty Syringe"), //item to derive from
        NameOverride = ModTag + "Penumbrate Syringe", //new item name with a suffix to assure it is globally unique
        DescriptionOverride = "Gives the user the ability of Penumbrate", //new item description
        CategoryOverride = ModAPI.FindCategory("Zuccians SuperHumans"), //new item category
        ThumbnailOverride = ModAPI.LoadSprite("suringe.png"), //new item thumbnail (relative path)
        AfterSpawn = (Instance) => //all code in the AfterSpawn delegate will be executed when the item is spawned
        {
             
            Instance.AddComponent<PenumbrateSyringe>();
            Instance.GetComponent<SpriteRenderer>().color = new Color32(0, 0, 50, 255);
        }
    }
);

ModAPI.Register(
    new Modification()
    {
        OriginalItem = ModAPI.FindSpawnable("Empty Syringe"), //item to derive from
        NameOverride = ModTag + "Snap Syringe", //new item name with a suffix to assure it is globally unique
        DescriptionOverride = "Gives the user the ability of Snap", //new item description
        CategoryOverride = ModAPI.FindCategory("Zuccians SuperHumans"), //new item category
        ThumbnailOverride = ModAPI.LoadSprite("suringe.png"), //new item thumbnail (relative path)
        AfterSpawn = (Instance) => //all code in the AfterSpawn delegate will be executed when the item is spawned
        {
             
            Instance.AddComponent<SnapSyringe>();
            Instance.GetComponent<SpriteRenderer>().color = new Color32(150, 150, 0, 255);
        }
    }
);

ModAPI.Register(
    new Modification()
    {
        OriginalItem = ModAPI.FindSpawnable("Empty Syringe"), //item to derive from
        NameOverride = ModTag + "Erasure Syringe", //new item name with a suffix to assure it is globally unique
        DescriptionOverride = "Gives the user the ability of Erasure", //new item description
        CategoryOverride = ModAPI.FindCategory("Zuccians SuperHumans"), //new item category
        ThumbnailOverride = ModAPI.LoadSprite("suringe.png"), //new item thumbnail (relative path)
        AfterSpawn = (Instance) => //all code in the AfterSpawn delegate will be executed when the item is spawned
        {
             
            Instance.AddComponent<ErasureSyringe>();
            Instance.GetComponent<SpriteRenderer>().color = new Color32(100, 50, 50, 255);
        }
    }
);

ModAPI.Register(
    new Modification()
    {
        OriginalItem = ModAPI.FindSpawnable("Empty Syringe"), //item to derive from
        NameOverride = ModTag + "Glimpse Syringe", //new item name with a suffix to assure it is globally unique
        DescriptionOverride = "Gives the user the ability of Glimpse", //new item description
        CategoryOverride = ModAPI.FindCategory("Zuccians SuperHumans"), //new item category
        ThumbnailOverride = ModAPI.LoadSprite("suringe.png"), //new item thumbnail (relative path)
        AfterSpawn = (Instance) => //all code in the AfterSpawn delegate will be executed when the item is spawned
        {
             
            Instance.AddComponent<GlimpseSyringe>();
            Instance.GetComponent<SpriteRenderer>().color = new Color32(150, 150, 110, 255);
        }
    }
);

            ModAPI.Register(
                new Modification()
                {
                    OriginalItem = ModAPI.FindSpawnable("Human"),
                    NameOverride = ModTag + "Halt",
                    DescriptionOverride = "Stops the momentum of all objects by activating his hands",
                    CategoryOverride = ModAPI.FindCategory("Zuccians SuperHumans"),
                    ThumbnailOverride = ModAPI.LoadSprite("hal.png"),
                    AfterSpawn = (Instance) =>
                    {
                        var skin = ModAPI.LoadTexture("Halt.png");
                        var flesh = ModAPI.LoadTexture("flesh layer.png");
                        var bone = ModAPI.LoadTexture("bone layer.png");

                        var person = Instance.GetComponent<PersonBehaviour>();

                        var arm1 = Instance.transform.Find("FrontArm").Find("LowerArmFront");
                        var arm2 = Instance.transform.Find("BackArm").Find("LowerArm");

                        arm1.gameObject.AddComponent<Halt>();
                        arm2.gameObject.AddComponent<Halt>();

                        foreach (var body in person.Limbs)
                        {
                  body.BaseStrength += 4.5f;
                  body.Health *= 80f;
                  body.InitialHealth *= 80f;
                  body.ShotDamageMultiplier *= 0.1f;
                  body.BreakingThreshold += 11f;
                  body.RegenerationSpeed += 30f;
                  body.Vitality *= 50f;
                  body.ImpactPainMultiplier *= 0.1f;
                  body.Numbness *= 1f;
                  body.CirculationBehaviour.BloodFlow *= 3000f;
                  body.IsLethalToBreak = false;
                        }

                        person.SetBodyTextures(skin, flesh, bone, 1);


          		    }
				}
			);
            ModAPI.Register(
                new Modification()
                {
                    OriginalItem = ModAPI.FindSpawnable("Human"),
                    NameOverride = ModTag + "Speed",
                    DescriptionOverride = "Multiplies the velocity of everything by activating his hands",
                    CategoryOverride = ModAPI.FindCategory("Zuccians SuperHumans"),
                    ThumbnailOverride = ModAPI.LoadSprite("speedt.png"),
                    AfterSpawn = (Instance) =>
                    {
                        var skin = ModAPI.LoadTexture("Speed.png");
                        var flesh = ModAPI.LoadTexture("flesh layer.png");
                        var bone = ModAPI.LoadTexture("bone layer.png");

                        var person = Instance.GetComponent<PersonBehaviour>();

                        var arm1 = Instance.transform.Find("FrontArm").Find("LowerArmFront");
                        var arm2 = Instance.transform.Find("BackArm").Find("LowerArm");

                        arm1.gameObject.AddComponent<Speed>();
                        arm2.gameObject.AddComponent<Speed>();

                        foreach (var body in person.Limbs)
                        {
                  body.BaseStrength += 4.5f;
                  body.Health *= 80f;
                  body.InitialHealth *= 80f;
                  body.ShotDamageMultiplier *= 0.1f;
                  body.BreakingThreshold += 11f;
                  body.RegenerationSpeed += 30f;
                  body.Vitality *= 50f;
                  body.ImpactPainMultiplier *= 0.1f;
                  body.Numbness *= 1f;
                  body.CirculationBehaviour.BloodFlow *= 3000f;
                  body.IsLethalToBreak = false;
                        }

                        person.SetBodyTextures(skin, flesh, bone, 1);


          		    }
				}
			);
            ModAPI.Register(
                new Modification()
                {
                    OriginalItem = ModAPI.FindSpawnable("Human"),
                    NameOverride = ModTag + "<color=#940003>TIME MASTER <color=white>Flow",
                    DescriptionOverride = "Sees into the future and outlines trajectories of objects up to 7 seconds by activating his head. Once this 7 seconds passes, the objects go back to their original position and follow the outlines trajectory. Time masters are not affected by this power",
                    CategoryOverride = ModAPI.FindCategory("Zuccians SuperHumans"),
                    ThumbnailOverride = ModAPI.LoadSprite("flowt.png"),
                    AfterSpawn = (Instance) =>
                    {
                        var skin = ModAPI.LoadTexture("Flow.png");
                        var flesh = ModAPI.LoadTexture("flesh layer.png");
                        var bone = ModAPI.LoadTexture("bone layer.png");

                        var person = Instance.GetComponent<PersonBehaviour>();

                        var head = Instance.transform.Find("Head");

                        head.gameObject.AddComponent<Flow>();

                        GameObject childObject = new GameObject("Glow2");
            childObject.transform.SetParent(head.gameObject.transform);
        childObject.transform.localPosition = new Vector3(0f, 0f);
        childObject.transform.localScale = new Vector3(1f, 1f);
        var childSprite = childObject.AddComponent<SpriteRenderer>();
        childSprite.sprite = ModAPI.LoadSprite("flowglow.png");
        childSprite.sharedMaterial = ModAPI.FindMaterial("VeryBright");
        childSprite.transform.position = head.transform.position;
        childSprite.transform.rotation = head.transform.rotation;
        childSprite.sortingLayerName = "Top";
        childSprite.color = Color.clear;
        head.gameObject.GetComponent<Flow>().dingy = childObject;

                        

                        foreach (var body in person.Limbs)
                        {
                  body.BaseStrength += 4.5f;
                  body.Health *= 80f;
                  body.InitialHealth *= 80f;
                  body.ShotDamageMultiplier *= 0.1f;
                  body.BreakingThreshold += 11f;
                  body.RegenerationSpeed += 30f;
                  body.Vitality *= 50f;
                  body.ImpactPainMultiplier *= 0.1f;
                  body.Numbness *= 1f;
                  body.CirculationBehaviour.BloodFlow *= 3000f;
                  body.IsLethalToBreak = false;
                  body.gameObject.AddComponent<q>();
                        }

                        person.SetBodyTextures(skin, flesh, bone, 1);


          		    }
				}
			);
            ModAPI.Register(
                new Modification()
                {
                    OriginalItem = ModAPI.FindSpawnable("Human"),
                    NameOverride = ModTag + "<color=#940003>TIME MASTER <color=white>Aureus",
                    DescriptionOverride = "Slows the flow of time drastically for everything except himself and other time masters for 10 seconds by activating his head",
                    CategoryOverride = ModAPI.FindCategory("Zuccians SuperHumans"),
                    ThumbnailOverride = ModAPI.LoadSprite("sist.png"),
                    AfterSpawn = (Instance) =>
                    {
                        var skin = ModAPI.LoadTexture("Aureus.png");
                        var flesh = ModAPI.LoadTexture("flesh layer.png");
                        var bone = ModAPI.LoadTexture("bone layer.png");

                        var person = Instance.GetComponent<PersonBehaviour>();

                        var head = Instance.transform.Find("Head");

                        head.gameObject.AddComponent<Aureus>();

                        GameObject childObject = new GameObject("Glow2");
            childObject.transform.SetParent(head.gameObject.transform);
        childObject.transform.localPosition = new Vector3(0f, 0f);
        childObject.transform.localScale = new Vector3(1f, 1f);
        var childSprite = childObject.AddComponent<SpriteRenderer>();
        childSprite.sprite = ModAPI.LoadSprite("flowglow.png");
        childSprite.sharedMaterial = ModAPI.FindMaterial("VeryBright");
        childSprite.transform.position = head.transform.position;
        childSprite.transform.rotation = head.transform.rotation;
        childSprite.sortingLayerName = "Top";
        childSprite.color = Color.clear;
        head.gameObject.GetComponent<Aureus>().dingy = childObject;

                        

                        foreach (var body in person.Limbs)
                        {
                  body.BaseStrength += 4.5f;
                  body.Health *= 80f;
                  body.InitialHealth *= 80f;
                  body.ShotDamageMultiplier *= 0.1f;
                  body.BreakingThreshold += 11f;
                  body.RegenerationSpeed += 30f;
                  body.Vitality *= 50f;
                  body.ImpactPainMultiplier *= 0.1f;
                  body.Numbness *= 1f;
                  body.CirculationBehaviour.BloodFlow *= 3000f;
                  body.IsLethalToBreak = false;
                  body.gameObject.AddComponent<q>();
                        }

                        person.SetBodyTextures(skin, flesh, bone, 1);


          		    }
				}
			);
            ModAPI.Register(
                new Modification()
                {
                    OriginalItem = ModAPI.FindSpawnable("Human"),
                    NameOverride = ModTag + "Fluon",
                    DescriptionOverride = "Shoots liquids from his arms, you can change the liquid he shoots by right clicking and choosing the options on his liquid pack. You can also hook syringes and other liquids up to the liquid pack",
                    CategoryOverride = ModAPI.FindCategory("Zuccians SuperHumans"),
                    ThumbnailOverride = ModAPI.LoadSprite("flut.png"),
                    AfterSpawn = (Instance) =>
                    {
                        var skin = ModAPI.LoadTexture("Fluon.png");
                        var flesh = ModAPI.LoadTexture("flesh layer.png");
                        var bone = ModAPI.LoadTexture("bone layer.png");

                        var person = Instance.GetComponent<PersonBehaviour>();

                        var arm1 = Instance.transform.Find("FrontArm").Find("LowerArmFront");
                        var arm2 = Instance.transform.Find("BackArm").Find("LowerArm");
                        var upper = Instance.transform.Find("Body").Find("UpperBody");

                        if (person.transform.localScale.x > 0) //left
                            {
                                GameObject tank = GameObject.Instantiate(ModAPI.FindSpawnable("Rod").Prefab);
                                tank.gameObject.AddComponent<FlaskBehaviour>();
                                tank.gameObject.GetComponent<FlaskBehaviour>().Capacity = 1000000f;
                        tank.transform.SetParent(upper.gameObject.transform);
                        tank.gameObject.GetComponent<SpriteRenderer>().sortingLayerName = "Top";
                        tank.gameObject.GetComponent<SpriteRenderer>().sprite = ModAPI.LoadSprite("tank.png");
                        tank.gameObject.GetComponent<SpriteRenderer>().sharedMaterial = ModAPI.FindMaterial("Sprites-Default");
                        tank.gameObject.GetComponent<PhysicalBehaviour>().HoldingPositions = new Vector3[0];
                            tank.FixColliders();
                            tank.gameObject.AddComponent<HoseTank>();
                            tank.gameObject.GetComponent<HoseTank>().human = upper.gameObject;
                    tank.transform.position = upper.gameObject.transform.position;
                    tank.transform.eulerAngles = upper.gameObject.transform.eulerAngles;
                    tank.gameObject.AddComponent<FixedJoint2D>();
                    tank.gameObject.GetComponent<FixedJoint2D>().connectedBody = upper.gameObject.gameObject.GetComponent<Rigidbody2D>();
                            tank.transform.localPosition = new Vector3(-0.1f, 0f);
                        foreach (var limbs in Instance.transform.root.gameObject.GetComponent<PersonBehaviour>().Limbs)
                        {
                        var Poop = limbs.gameObject.AddComponent<NoCollide>();
                        Poop.NoCollideSetA = tank.GetComponentsInChildren<Collider2D>();
                        Poop.NoCollideSetB = limbs.gameObject.GetComponentsInChildren<Collider2D>();
                        }

                                GameObject Item3 = GameObject.Instantiate(ModAPI.FindSpawnable("Rod").Prefab);
                                tank.gameObject.GetComponent<HoseTank>().hose1 = Item3;
                        Item3.transform.SetParent(arm1.gameObject.transform);
                        Item3.gameObject.GetComponent<SpriteRenderer>().sortingLayerName = "Top";
                        Item3.gameObject.GetComponent<SpriteRenderer>().sprite = ModAPI.LoadSprite("arm.png");
                        Item3.gameObject.GetComponent<SpriteRenderer>().sharedMaterial = ModAPI.FindMaterial("Sprites-Default");
                        Item3.gameObject.GetComponent<PhysicalBehaviour>().HoldingPositions = new Vector3[0];
                            Item3.FixColliders();
                            Item3.gameObject.AddComponent<Hose>();
                    Item3.transform.position = arm1.gameObject.transform.position;
                    Item3.transform.eulerAngles = arm1.gameObject.transform.eulerAngles;
                    Item3.gameObject.AddComponent<FixedJoint2D>();
                    Item3.gameObject.GetComponent<FixedJoint2D>().connectedBody = arm1.gameObject.gameObject.GetComponent<Rigidbody2D>();
                            Item3.transform.localPosition = new Vector3(-0.1f, 0f);
                        foreach (var limbs in Instance.transform.root.gameObject.GetComponent<PersonBehaviour>().Limbs)
                        {
                            Item3.gameObject.GetComponent<Hose>().mrkrinkle = limbs.gameObject;
                        var Poop = limbs.gameObject.AddComponent<NoCollide>();
                        Poop.NoCollideSetA = Item3.GetComponentsInChildren<Collider2D>();
                        Poop.NoCollideSetB = limbs.gameObject.GetComponentsInChildren<Collider2D>();
                        }
                        GameObject Item4 = GameObject.Instantiate(ModAPI.FindSpawnable("Rod").Prefab);
                        tank.gameObject.GetComponent<HoseTank>().hose2 = Item4;
                        Item4.transform.SetParent(arm2.gameObject.transform);
                        Item4.gameObject.GetComponent<SpriteRenderer>().sortingLayerName = "Top";
                        Item4.gameObject.GetComponent<SpriteRenderer>().sprite = ModAPI.LoadSprite("arm.png");
                        Item4.gameObject.GetComponent<SpriteRenderer>().sharedMaterial = ModAPI.FindMaterial("Sprites-Default");
                        Item4.gameObject.GetComponent<PhysicalBehaviour>().HoldingPositions = new Vector3[0];
                            Item4.FixColliders();
                            Item4.gameObject.AddComponent<Hose>();
                    Item4.transform.position = arm2.gameObject.transform.position;
                    Item4.transform.eulerAngles = arm2.gameObject.transform.eulerAngles;
                    Item4.gameObject.AddComponent<FixedJoint2D>();
                    Item4.gameObject.GetComponent<FixedJoint2D>().connectedBody = arm2.gameObject.gameObject.GetComponent<Rigidbody2D>();
                            Item4.transform.localPosition = new Vector3(-0.1f, 0f);
                        foreach (var limbs in Instance.transform.root.gameObject.GetComponent<PersonBehaviour>().Limbs)
                        {
                            Item4.gameObject.GetComponent<Hose>().mrkrinkle = limbs.gameObject;
                        var Poop2 = limbs.gameObject.AddComponent<NoCollide>();
                        Poop2.NoCollideSetA = Item4.GetComponentsInChildren<Collider2D>();
                        Poop2.NoCollideSetB = limbs.gameObject.GetComponentsInChildren<Collider2D>();
                        }
                            }
                            else
                            {
                               GameObject tank = GameObject.Instantiate(ModAPI.FindSpawnable("Rod").Prefab);
                               tank.gameObject.AddComponent<FlaskBehaviour>();
                               tank.gameObject.GetComponent<FlaskBehaviour>().Capacity = 1000000f;
                        tank.transform.SetParent(upper.gameObject.transform);
                        tank.gameObject.GetComponent<SpriteRenderer>().sortingLayerName = "Top";
                        tank.gameObject.GetComponent<SpriteRenderer>().sprite = ModAPI.LoadSprite("tank2.png");
                        tank.gameObject.GetComponent<SpriteRenderer>().sharedMaterial = ModAPI.FindMaterial("Sprites-Default");
                        tank.gameObject.GetComponent<PhysicalBehaviour>().HoldingPositions = new Vector3[0];
                            tank.FixColliders();
                            tank.gameObject.AddComponent<HoseTank>();
                            tank.gameObject.GetComponent<HoseTank>().human = upper.gameObject;
                    tank.transform.position = upper.gameObject.transform.position;
                    tank.transform.eulerAngles = upper.gameObject.transform.eulerAngles;
                    tank.gameObject.AddComponent<FixedJoint2D>();
                    tank.gameObject.GetComponent<FixedJoint2D>().connectedBody = upper.gameObject.gameObject.GetComponent<Rigidbody2D>();
                            tank.transform.localPosition = new Vector3(-0.1f, 0f);
                        foreach (var limbs in Instance.transform.root.gameObject.GetComponent<PersonBehaviour>().Limbs)
                        {
                        var Poop = limbs.gameObject.AddComponent<NoCollide>();
                        Poop.NoCollideSetA = tank.GetComponentsInChildren<Collider2D>();
                        Poop.NoCollideSetB = limbs.gameObject.GetComponentsInChildren<Collider2D>();
                        }

                                GameObject Item3 = GameObject.Instantiate(ModAPI.FindSpawnable("Rod").Prefab);
                                tank.gameObject.GetComponent<HoseTank>().hose1 = Item3;
                        Item3.transform.SetParent(arm1.gameObject.transform);
                        Item3.gameObject.GetComponent<SpriteRenderer>().sortingLayerName = "Top";
                        Item3.gameObject.GetComponent<SpriteRenderer>().sprite = ModAPI.LoadSprite("arm2.png");
                        Item3.gameObject.GetComponent<SpriteRenderer>().sharedMaterial = ModAPI.FindMaterial("Sprites-Default");
                        Item3.gameObject.GetComponent<PhysicalBehaviour>().HoldingPositions = new Vector3[0];
                            Item3.FixColliders();
                            Item3.gameObject.AddComponent<Hose>();
                    Item3.transform.position = arm1.gameObject.transform.position;
                    Item3.transform.eulerAngles = arm1.gameObject.transform.eulerAngles;
                    Item3.gameObject.AddComponent<FixedJoint2D>();
                    Item3.gameObject.GetComponent<FixedJoint2D>().connectedBody = arm1.gameObject.gameObject.GetComponent<Rigidbody2D>();
                            Item3.transform.localPosition = new Vector3(-0.1f, 0f);
                        foreach (var limbs in Instance.transform.root.gameObject.GetComponent<PersonBehaviour>().Limbs)
                        {
                            Item3.gameObject.GetComponent<Hose>().mrkrinkle = limbs.gameObject;
                        var Poop = limbs.gameObject.AddComponent<NoCollide>();
                        Poop.NoCollideSetA = Item3.GetComponentsInChildren<Collider2D>();
                        Poop.NoCollideSetB = limbs.gameObject.GetComponentsInChildren<Collider2D>();
                        }
                        GameObject Item4 = GameObject.Instantiate(ModAPI.FindSpawnable("Rod").Prefab);
                        tank.gameObject.GetComponent<HoseTank>().hose2 = Item4;
                        Item4.transform.SetParent(arm2.gameObject.transform);
                        Item4.gameObject.GetComponent<SpriteRenderer>().sortingLayerName = "Top";
                        Item4.gameObject.GetComponent<SpriteRenderer>().sprite = ModAPI.LoadSprite("arm2.png");
                        Item4.gameObject.GetComponent<SpriteRenderer>().sharedMaterial = ModAPI.FindMaterial("Sprites-Default");
                        Item4.gameObject.GetComponent<PhysicalBehaviour>().HoldingPositions = new Vector3[0];
                            Item4.FixColliders();
                            Item4.gameObject.AddComponent<Hose>();
                    Item4.transform.position = arm2.gameObject.transform.position;
                    Item4.transform.eulerAngles = arm2.gameObject.transform.eulerAngles;
                    Item4.gameObject.AddComponent<FixedJoint2D>();
                    Item4.gameObject.GetComponent<FixedJoint2D>().connectedBody = arm2.gameObject.gameObject.GetComponent<Rigidbody2D>();
                            Item4.transform.localPosition = new Vector3(-0.1f, 0f);
                        foreach (var limbs in Instance.transform.root.gameObject.GetComponent<PersonBehaviour>().Limbs)
                        {
                            Item4.gameObject.GetComponent<Hose>().mrkrinkle = limbs.gameObject;
                        var Poop2 = limbs.gameObject.AddComponent<NoCollide>();
                        Poop2.NoCollideSetA = Item4.GetComponentsInChildren<Collider2D>();
                        Poop2.NoCollideSetB = limbs.gameObject.GetComponentsInChildren<Collider2D>();
                        }
                            }

                        foreach (var body in person.Limbs)
                        {
                  body.BaseStrength += 4.5f;
                  body.Health *= 80f;
                  body.InitialHealth *= 80f;
                  body.ShotDamageMultiplier *= 0.1f;
                  body.BreakingThreshold += 11f;
                  body.RegenerationSpeed += 30f;
                  body.Vitality *= 50f;
                  body.ImpactPainMultiplier *= 0.1f;
                  body.Numbness *= 1f;
                  body.CirculationBehaviour.BloodFlow *= 3000f;
                  body.IsLethalToBreak = false;
                        }

                        person.SetBodyTextures(skin, flesh, bone, 1);


          		    }
				}
			);
            ModAPI.Register(
                new Modification()
                {
                    OriginalItem = ModAPI.FindSpawnable("Human"),
                    NameOverride = ModTag + "<color=#940003>TIME MASTER <color=white>Reversion",
                    DescriptionOverride = "Makes save states of time by activating his front hand and can load save states by activating his back hand. Time masters are not affected by his power",
                    CategoryOverride = ModAPI.FindCategory("Zuccians SuperHumans"),
                    ThumbnailOverride = ModAPI.LoadSprite("rev.png"),
                    AfterSpawn = (Instance) =>
                    {
                        var skin = ModAPI.LoadTexture("Reversion.png");
                        var flesh = ModAPI.LoadTexture("flesh layer.png");
                        var bone = ModAPI.LoadTexture("bone layer.png");

                        var person = Instance.GetComponent<PersonBehaviour>();

                        var arm1 = Instance.transform.Find("FrontArm").Find("LowerArmFront");
                        var arm2 = Instance.transform.Find("BackArm").Find("LowerArm");

                        arm1.gameObject.AddComponent<Reversion>();
                        arm1.gameObject.GetComponent<Reversion>().arm1 = arm1.gameObject;
                        arm1.gameObject.GetComponent<Reversion>().arm2 = arm2.gameObject;



                        

                        foreach (var body in person.Limbs)
                        {
                  body.BaseStrength += 4.5f;
                  body.Health *= 80f;
                  body.InitialHealth *= 80f;
                  body.ShotDamageMultiplier *= 0.1f;
                  body.BreakingThreshold += 11f;
                  body.RegenerationSpeed += 30f;
                  body.Vitality *= 50f;
                  body.ImpactPainMultiplier *= 0.1f;
                  body.Numbness *= 1f;
                  body.CirculationBehaviour.BloodFlow *= 3000f;
                  body.IsLethalToBreak = false;
                  body.gameObject.AddComponent<q>();
                        }

                        person.SetBodyTextures(skin, flesh, bone, 1);


          		    }
				}
			);
            ModAPI.Register(
                new Modification()
                {
                    OriginalItem = ModAPI.FindSpawnable("Human"),
                    NameOverride = ModTag + "Tension",
                    DescriptionOverride = "Wooden doll that can become anyone who touches its head by activating its head, activating it again will turn it back into a doll",
                    CategoryOverride = ModAPI.FindCategory("Zuccians SuperHumans"),
                    ThumbnailOverride = ModAPI.LoadSprite("tent.png"),
                    AfterSpawn = (Instance) =>
                    {
                        var skin = ModAPI.LoadTexture("Tension.png");
                        var flesh = ModAPI.LoadTexture("Tension.png");
                        var bone = ModAPI.LoadTexture("Tension.png");

                        var person = Instance.GetComponent<PersonBehaviour>();

                        var head = Instance.transform.Find("Head");

                        head.gameObject.AddComponent<Tension>();


                       person.BoneBreakClips = new AudioClip[] 
                      { 
                   ModAPI.LoadSound("null.wav") 
                      };
                         

                        foreach (var body in person.Limbs)
                        {
                  body.BaseStrength += 4.5f;
                  body.Health *= 80f;
                  body.InitialHealth *= 80f;
                  body.ShotDamageMultiplier *= 0.1f;
                  body.BreakingThreshold += 11f;
                  body.RegenerationSpeed += 30f;
                  body.Vitality *= 50f;
                  body.ImpactPainMultiplier *= 0.1f;
                  body.Numbness *= 1f;
                  body.CirculationBehaviour.BloodFlow *= 3000f;
                  body.IsLethalToBreak = false;
                  body.Broken = true;
                  body.gameObject.GetComponent<PhysicalBehaviour>().Properties = ModAPI.FindPhysicalProperties("Wood");
                        }

                        person.SetBodyTextures(skin, flesh, bone, 1);


          		    }
				}
			);
            ModAPI.Register(
                new Modification()
                {
                    OriginalItem = ModAPI.FindSpawnable("Human"),
                    NameOverride = ModTag + "Puzzlr",
                    DescriptionOverride = "Shoots puzzle pieces from his hands, anything that these puzzle pieces touch will be erased and 2 more puzzle pieces will spawn in its place. This spreads like hell",
                    CategoryOverride = ModAPI.FindCategory("Zuccians SuperHumans"),
                    ThumbnailOverride = ModAPI.LoadSprite("puz.png"),
                    AfterSpawn = (Instance) =>
                    {
                        var skin = ModAPI.LoadTexture("Puzzlr.png");
                        var flesh = ModAPI.LoadTexture("flesh layer.png");
                        var bone = ModAPI.LoadTexture("bone layer.png");

                        var person = Instance.GetComponent<PersonBehaviour>();

                        var arm1 = Instance.transform.Find("FrontArm").Find("LowerArmFront");
                        var arm2 = Instance.transform.Find("BackArm").Find("LowerArm");

                             arm1.gameObject.AddComponent<UseEventTrigger>().Action = () =>
                {
                    GameObject Projectile = GameObject.Instantiate(ModAPI.FindSpawnable("puzzlrpiece").Prefab);
                    CatalogBehaviour.PerformMod(ModAPI.FindSpawnable("puzzlrpiece"), Projectile);
                    Projectile.transform.rotation = arm1.transform.rotation;
                    Projectile.transform.eulerAngles += new Vector3(0, 0, 180);
                    Projectile.transform.position = arm1.transform.position + (-arm1.transform.up * 0.5f);
                    Projectile.GetComponent<Rigidbody2D>().AddRelativeForce(Projectile.transform.up * 466);
                };

                arm2.gameObject.AddComponent<UseEventTrigger>().Action = () =>
   {
       GameObject Projectile = GameObject.Instantiate(ModAPI.FindSpawnable("puzzlrpiece").Prefab);
       CatalogBehaviour.PerformMod(ModAPI.FindSpawnable("puzzlrpiece"), Projectile);
       Projectile.transform.rotation = arm2.transform.rotation;
       Projectile.transform.eulerAngles += new Vector3(0, 0, 180);
       Projectile.transform.position = arm2.transform.position + (-arm2.transform.up * 0.5f);
       Projectile.GetComponent<Rigidbody2D>().AddRelativeForce(Projectile.transform.up * 466);
   };
                         
                        foreach (var body in person.Limbs)
                        {
                  body.BaseStrength += 4.5f;
                  body.Health *= 80f;
                  body.InitialHealth *= 80f;
                  body.ShotDamageMultiplier *= 0.1f;
                  body.BreakingThreshold += 11f;
                  body.RegenerationSpeed += 30f;
                  body.Vitality *= 50f;
                  body.ImpactPainMultiplier *= 0.1f;
                  body.Numbness *= 1f;
                  body.CirculationBehaviour.BloodFlow *= 3000f;
                  body.IsLethalToBreak = false;
                        }

                        person.SetBodyTextures(skin, flesh, bone, 1);


          		    }
				}
			);
            ModAPI.Register(
                new Modification()
                {
                    OriginalItem = ModAPI.FindSpawnable("Brick"),
                    NameOverride = "puzzlrpiece",
                    DescriptionOverride = " ",
                    CategoryOverride = ModAPI.FindCategory(" "),
                    ThumbnailOverride = ModAPI.LoadSprite(" .png"),
                    AfterSpawn = (Instance) =>
                    {
                      Instance.GetComponent<SpriteRenderer>().sprite = ModAPI.LoadSprite("puzzlrpiece.png");
                      var properties = ModAPI.FindPhysicalProperties("Human");
        Instance.GetComponent<PhysicalBehaviour>().Properties = properties; 
                      Instance.FixColliders();
                      Instance.GetComponent<PolygonCollider2D>().isTrigger = true;
                      Instance.AddComponent<puzzlrpiece>();
                    }
                }
            );
            ModAPI.Register(
                new Modification()
                {
                    OriginalItem = ModAPI.FindSpawnable("Human"),
                    NameOverride = ModTag + "Lotus",
                    DescriptionOverride = "Makes poisonous flowers by touching something and activating his hands. Making the flower on a human will cause severe damage to it and making the flower on any machine will break it",
                    CategoryOverride = ModAPI.FindCategory("Zuccians SuperHumans"),
                    ThumbnailOverride = ModAPI.LoadSprite("lot.png"),
                    AfterSpawn = (Instance) =>
                    {
                        var skin = ModAPI.LoadTexture("Lotus.png");
                        var flesh = ModAPI.LoadTexture("flesh layer.png");
                        var bone = ModAPI.LoadTexture("bone layer.png");

                        var person = Instance.GetComponent<PersonBehaviour>();

                        var arm1 = Instance.transform.Find("FrontArm").Find("LowerArmFront");
                        var arm2 = Instance.transform.Find("BackArm").Find("LowerArm");

                        arm1.gameObject.AddComponent<Lotus>();
                        arm2.gameObject.AddComponent<Lotus>();
                         
                        foreach (var body in person.Limbs)
                        {
                  body.BaseStrength += 4.5f;
                  body.Health *= 80f;
                  body.InitialHealth *= 80f;
                  body.ShotDamageMultiplier *= 0.1f;
                  body.BreakingThreshold += 11f;
                  body.RegenerationSpeed += 30f;
                  body.Vitality *= 50f;
                  body.ImpactPainMultiplier *= 0.1f;
                  body.Numbness *= 1f;
                  body.CirculationBehaviour.BloodFlow *= 3000f;
                  body.IsLethalToBreak = false;
                        }

                        person.SetBodyTextures(skin, flesh, bone, 1);


          		    }
				}
			);
            ModAPI.Register(
    new Modification()
    {
        OriginalItem = ModAPI.FindSpawnable("Insulator"),
        NameOverride = "lotusflower",
        DescriptionOverride = "lotusflower", 
        CategoryOverride = ModAPI.FindCategory(" "), 
        ThumbnailOverride = ModAPI.LoadSprite("flower.png"), 
        AfterSpawn = (Instance) => 
        {
            Instance.GetComponent<SpriteRenderer>().sprite = ModAPI.LoadSprite("flower.png");
            Instance.GetComponent<PhysicalBehaviour>().MakeWeightless();
            Instance.FixColliders();
                           }
                        }
                      );
                      ModAPI.Register(
                new Modification()
                {
                    OriginalItem = ModAPI.FindSpawnable("Human"),
                    NameOverride = ModTag + "<color=#940003>TIME MASTER <color=white>Antipode",
                    DescriptionOverride = "Makes a save state of time every 7 seconds, activating his head rewinds to whatever save state he has made. Time masters are not affected by his power",
                    CategoryOverride = ModAPI.FindCategory("Zuccians SuperHumans"),
                    ThumbnailOverride = ModAPI.LoadSprite("antit.png"),
                    AfterSpawn = (Instance) =>
                    {
                        var skin = ModAPI.LoadTexture("Antipode.png");
                        var flesh = ModAPI.LoadTexture("flesh layer.png");
                        var bone = ModAPI.LoadTexture("bone layer.png");

                        var person = Instance.GetComponent<PersonBehaviour>();

                        var head = Instance.transform.Find("Head");

                        head.gameObject.AddComponent<Antipode>();
                         

                        foreach (var body in person.Limbs)
                        {
                  body.BaseStrength += 4.5f;
                  body.Health *= 80f;
                  body.InitialHealth *= 80f;
                  body.ShotDamageMultiplier *= 0.1f;
                  body.BreakingThreshold += 11f;
                  body.RegenerationSpeed += 30f;
                  body.Vitality *= 50f;
                  body.ImpactPainMultiplier *= 0.1f;
                  body.Numbness *= 1f;
                  body.CirculationBehaviour.BloodFlow *= 3000f;
                  body.IsLethalToBreak = false;
                  body.gameObject.AddComponent<q>();
                        }

                        person.SetBodyTextures(skin, flesh, bone, 1);


          		    }
				}
			);
            ModAPI.Register(
                new Modification()
                {
                    OriginalItem = ModAPI.FindSpawnable("Human"),
                    NameOverride = ModTag + "Agenda",
                    DescriptionOverride = "Shoots playing cards out of his hands, these cards can trap any object and upon activation they release whatever object they trapped and delete themself",
                    CategoryOverride = ModAPI.FindCategory("Zuccians SuperHumans"),
                    ThumbnailOverride = ModAPI.LoadSprite("agendat.png"),
                    AfterSpawn = (Instance) =>
                    {
                        var skin = ModAPI.LoadTexture("Agenda.png");
                        var flesh = ModAPI.LoadTexture("flesh layer.png");
                        var bone = ModAPI.LoadTexture("bone layer.png");

                        var person = Instance.GetComponent<PersonBehaviour>();

                        var arm1 = Instance.transform.Find("FrontArm").Find("LowerArmFront");
                        var arm2 = Instance.transform.Find("BackArm").Find("LowerArm");

                             arm1.gameObject.AddComponent<UseEventTrigger>().Action = () =>
                {
                    GameObject Projectile = GameObject.Instantiate(ModAPI.FindSpawnable("agendacard").Prefab);
                    CatalogBehaviour.PerformMod(ModAPI.FindSpawnable("agendacard"), Projectile);
                    Projectile.transform.rotation = arm1.transform.rotation;
                    Projectile.transform.eulerAngles += new Vector3(0, 0, 180);
                    Projectile.transform.position = arm1.transform.position + (-arm1.transform.up * 0.5f);
                    Projectile.GetComponent<Rigidbody2D>().AddRelativeForce(Projectile.transform.up * 46);
                };

                arm2.gameObject.AddComponent<UseEventTrigger>().Action = () =>
   {
       GameObject Projectile = GameObject.Instantiate(ModAPI.FindSpawnable("agendacard").Prefab);
       CatalogBehaviour.PerformMod(ModAPI.FindSpawnable("agendacard"), Projectile);
       Projectile.transform.rotation = arm2.transform.rotation;
       Projectile.transform.eulerAngles += new Vector3(0, 0, 180);
       Projectile.transform.position = arm2.transform.position + (-arm2.transform.up * 0.5f);
       Projectile.GetComponent<Rigidbody2D>().AddRelativeForce(Projectile.transform.up * 46);
   };
                         
                        foreach (var body in person.Limbs)
                        {
                  body.BaseStrength += 4.5f;
                  body.Health *= 80f;
                  body.InitialHealth *= 80f;
                  body.ShotDamageMultiplier *= 0.1f;
                  body.BreakingThreshold += 11f;
                  body.RegenerationSpeed += 30f;
                  body.Vitality *= 50f;
                  body.ImpactPainMultiplier *= 0.1f;
                  body.Numbness *= 1f;
                  body.CirculationBehaviour.BloodFlow *= 3000f;
                  body.IsLethalToBreak = false;
                        }

                        person.SetBodyTextures(skin, flesh, bone, 1);


          		    }
				}
			);
            ModAPI.Register(
                new Modification()
                {
                    OriginalItem = ModAPI.FindSpawnable("Rod"),
                    NameOverride = "agendacard",
                    DescriptionOverride = " ",
                    CategoryOverride = ModAPI.FindCategory(" "),
                    ThumbnailOverride = ModAPI.LoadSprite(" .png"),
                    AfterSpawn = (Instance) =>
                    {
                      Instance.GetComponent<SpriteRenderer>().sprite = ModAPI.LoadSprite("card.png");
                      Instance.FixColliders();
                      Instance.AddComponent<Card>();
                    }
                }
            );
            ModAPI.Register(
                new Modification()
                {
                    OriginalItem = ModAPI.FindSpawnable("Human"),
                    NameOverride = ModTag + "Purain",
                    DescriptionOverride = "Makes a flow of water by holding his front hand, activating his back hand will give him complete control of the water, and activating it again will launch the water from his hand",
                    CategoryOverride = ModAPI.FindCategory("Zuccians SuperHumans"),
                    ThumbnailOverride = ModAPI.LoadSprite("purt.png"),
                    AfterSpawn = (Instance) =>
                    {
                        var skin = ModAPI.LoadTexture("Purain.png");
                        var flesh = ModAPI.LoadTexture("flesh layer.png");
                        var bone = ModAPI.LoadTexture("bone layer.png");

                        var person = Instance.GetComponent<PersonBehaviour>();

                        var arm1 = Instance.transform.Find("FrontArm").Find("LowerArmFront");
                        var arm2 = Instance.transform.Find("BackArm").Find("LowerArm");

                        arm1.gameObject.AddComponent<Water>();
                        arm1.gameObject.GetComponent<Water>().armthing = arm2.gameObject;
                        arm1.gameObject.GetComponent<Water>().mrkrinkle = arm1.gameObject;
                         
                        foreach (var body in person.Limbs)
                        {
                  body.BaseStrength += 4.5f;
                  body.Health *= 80f;
                  body.InitialHealth *= 80f;
                  body.ShotDamageMultiplier *= 0.1f;
                  body.BreakingThreshold += 11f;
                  body.RegenerationSpeed += 30f;
                  body.Vitality *= 50f;
                  body.ImpactPainMultiplier *= 0.1f;
                  body.Numbness *= 1f;
                  body.CirculationBehaviour.BloodFlow *= 3000f;
                  body.IsLethalToBreak = false;
                        }

                        person.SetBodyTextures(skin, flesh, bone, 1);


          		    }
				}
			);
            ModAPI.Register(
                new Modification()
                {
                    OriginalItem = ModAPI.FindSpawnable("Human"),
                    NameOverride = ModTag + "Infernate",
                    DescriptionOverride = "Makes a flow of lava by holding his front hand, activating his back hand will give him complete control of the lava, and activating it again will launch the lava from his hand",
                    CategoryOverride = ModAPI.FindCategory("Zuccians SuperHumans"),
                    ThumbnailOverride = ModAPI.LoadSprite("int.png"),
                    AfterSpawn = (Instance) =>
                    {
                        var skin = ModAPI.LoadTexture("Infernate.png");
                        var flesh = ModAPI.LoadTexture("flesh layer.png");
                        var bone = ModAPI.LoadTexture("bone layer.png");

                        var person = Instance.GetComponent<PersonBehaviour>();

                        var arm1 = Instance.transform.Find("FrontArm").Find("LowerArmFront");
                        var arm2 = Instance.transform.Find("BackArm").Find("LowerArm");

                        arm1.gameObject.AddComponent<Fire>();
                        arm1.gameObject.GetComponent<Fire>().armthing = arm2.gameObject;
                        arm1.gameObject.GetComponent<Fire>().mrkrinkle = arm1.gameObject;
                         
                        foreach (var body in person.Limbs)
                        {
                  body.BaseStrength += 4.5f;
                  body.Health *= 80f;
                  body.InitialHealth *= 80f;
                  body.ShotDamageMultiplier *= 0.1f;
                  body.BreakingThreshold += 11f;
                  body.RegenerationSpeed += 30f;
                  body.Vitality *= 50f;
                  body.ImpactPainMultiplier *= 0.1f;
                  body.Numbness *= 1f;
                  body.CirculationBehaviour.BloodFlow *= 3000f;
                  body.IsLethalToBreak = false;
                        }

                        person.SetBodyTextures(skin, flesh, bone, 1);


          		    }
				}
			);
            ModAPI.Register(
                new Modification()
                {
                    OriginalItem = ModAPI.FindSpawnable("Human"),
                    NameOverride = ModTag + "Trance",
                    DescriptionOverride = "Creates a ghost like clone of himself by activating his head, this clone is very sensitive but can be spawned multiple times. Activating his head again will cause the ghost to disappear",
                    CategoryOverride = ModAPI.FindCategory("Zuccians SuperHumans"),
                    ThumbnailOverride = ModAPI.LoadSprite("tran.png"),
                    AfterSpawn = (Instance) =>
                    {
                        var skin = ModAPI.LoadTexture("Trance.png");
                        var flesh = ModAPI.LoadTexture("flesh layer.png");
                        var bone = ModAPI.LoadTexture("bone layer.png");

                        var person = Instance.GetComponent<PersonBehaviour>();

                        var head = Instance.transform.Find("Head");

                        head.gameObject.AddComponent<Trance>();
                         

                        foreach (var body in person.Limbs)
                        {
                  body.BaseStrength += 4.5f;
                  body.Health *= 80f;
                  body.InitialHealth *= 80f;
                  body.ShotDamageMultiplier *= 0.1f;
                  body.BreakingThreshold += 11f;
                  body.RegenerationSpeed += 30f;
                  body.Vitality *= 50f;
                  body.ImpactPainMultiplier *= 0.1f;
                  body.Numbness *= 1f;
                  body.CirculationBehaviour.BloodFlow *= 3000f;
                  body.IsLethalToBreak = false;
                        }

                        person.SetBodyTextures(skin, flesh, bone, 1);


          		    }
				}
			);
            ModAPI.Register(
                new Modification()
                {
                    OriginalItem = ModAPI.FindSpawnable("Human"),
                    NameOverride = ModTag + "Shade",
                    DescriptionOverride = "Similar to Trance, but the ghost he creates has no collision and can go to the position of the host by activating its head, and activating Shades head will set his position to the position of the ghost",
                    CategoryOverride = ModAPI.FindCategory("Zuccians SuperHumans"),
                    ThumbnailOverride = ModAPI.LoadSprite("shadet.png"),
                    AfterSpawn = (Instance) =>
                    {
                        var skin = ModAPI.LoadTexture("Shade.png");
                        var flesh = ModAPI.LoadTexture("flesh layer.png");
                        var bone = ModAPI.LoadTexture("bone layer.png");

                        var person = Instance.GetComponent<PersonBehaviour>();

                        var head = Instance.transform.Find("Head");

                        head.gameObject.AddComponent<Shade>();
                         

                        foreach (var body in person.Limbs)
                        {
                  body.BaseStrength += 4.5f;
                  body.Health *= 80f;
                  body.InitialHealth *= 80f;
                  body.ShotDamageMultiplier *= 0.1f;
                  body.BreakingThreshold += 11f;
                  body.RegenerationSpeed += 30f;
                  body.Vitality *= 50f;
                  body.ImpactPainMultiplier *= 0.1f;
                  body.Numbness *= 1f;
                  body.CirculationBehaviour.BloodFlow *= 3000f;
                  body.IsLethalToBreak = false;
                        }

                        person.SetBodyTextures(skin, flesh, bone, 1);


          		    }
				}
			);
            ModAPI.Register(
                new Modification()
                {
                    OriginalItem = ModAPI.FindSpawnable("Human"),
                    NameOverride = "shadeclone",
                    DescriptionOverride = "Creates a ghost like clone of himself by activating his head, this clone is very sensitive but can be spawned multiple times. Activating his head again will cause the ghost to disappear",
                    CategoryOverride = ModAPI.FindCategory(" "),
                    ThumbnailOverride = ModAPI.LoadSprite("tran.png"),
                    AfterSpawn = (Instance) =>
                    {
                        var skin = ModAPI.LoadTexture("sc.png");
                        var flesh = ModAPI.LoadTexture("flesh layer.png");
                        var bone = ModAPI.LoadTexture("bone layer.png");

                        var person = Instance.GetComponent<PersonBehaviour>();

                        foreach (var body in person.Limbs)
                        {
                  body.BaseStrength += 4.5f;
                  body.Health *= 80f;
                  body.InitialHealth *= 80f;
                  body.ShotDamageMultiplier *= 0.1f;
                  body.BreakingThreshold += 11f;
                  body.RegenerationSpeed += 30f;
                  body.Vitality *= 50f;
                  body.ImpactPainMultiplier *= 0.1f;
                  body.Numbness *= 1f;
                  body.CirculationBehaviour.BloodFlow *= 3000f;
                  body.IsLethalToBreak = false;
                        }

                        person.SetBodyTextures(skin, flesh, bone, 1);


          		    }
				}
			);
            ModAPI.Register(
                new Modification()
                {
                    OriginalItem = ModAPI.FindSpawnable("Human"),
                    NameOverride = ModTag + "Penumbrate",
                    DescriptionOverride = "Turns any dead human in an area into his minion by activating his head",
                    CategoryOverride = ModAPI.FindCategory("Zuccians SuperHumans"),
                    ThumbnailOverride = ModAPI.LoadSprite("pent.png"),
                    AfterSpawn = (Instance) =>
                    {
                        var skin = ModAPI.LoadTexture("Penumbrate.png");
                        var flesh = ModAPI.LoadTexture("flesh layer.png");
                        var bone = ModAPI.LoadTexture("bone layer.png");

                        var person = Instance.GetComponent<PersonBehaviour>();

                        var head = Instance.transform.Find("Head");

                        head.gameObject.AddComponent<Penumbrate>();
                         

                        foreach (var body in person.Limbs)
                        {
                  body.BaseStrength += 4.5f;
                  body.Health *= 80f;
                  body.InitialHealth *= 80f;
                  body.ShotDamageMultiplier *= 0.1f;
                  body.BreakingThreshold += 11f;
                  body.RegenerationSpeed += 30f;
                  body.Vitality *= 50f;
                  body.ImpactPainMultiplier *= 0.1f;
                  body.Numbness *= 1f;
                  body.CirculationBehaviour.BloodFlow *= 3000f;
                  body.IsLethalToBreak = false;
                        }

                        person.SetBodyTextures(skin, flesh, bone, 1);


          		    }
				}
			);
            ModAPI.Register(
                new Modification()
                {
                    OriginalItem = ModAPI.FindSpawnable("Human"),
                    NameOverride = ModTag + "Erasure",
                    DescriptionOverride = "Activating his head will skip into the future, simple as that",
                    CategoryOverride = ModAPI.FindCategory("Zuccians SuperHumans"),
                    ThumbnailOverride = ModAPI.LoadSprite("et.png"),
                    AfterSpawn = (Instance) =>
                    {
                        var skin = ModAPI.LoadTexture("Erasure.png");
                        var flesh = ModAPI.LoadTexture("flesh layer.png");
                        var bone = ModAPI.LoadTexture("bone layer.png");

                        var person = Instance.GetComponent<PersonBehaviour>();

                        var head = Instance.transform.Find("Head");

                        head.gameObject.AddComponent<Erasure>();
                         

                        foreach (var body in person.Limbs)
                        {
                  body.BaseStrength += 4.5f;
                  body.Health *= 80f;
                  body.InitialHealth *= 80f;
                  body.ShotDamageMultiplier *= 0.1f;
                  body.BreakingThreshold += 11f;
                  body.RegenerationSpeed += 30f;
                  body.Vitality *= 50f;
                  body.ImpactPainMultiplier *= 0.1f;
                  body.Numbness *= 1f;
                  body.CirculationBehaviour.BloodFlow *= 3000f;
                  body.IsLethalToBreak = false;
                        }

                        person.SetBodyTextures(skin, flesh, bone, 1);


          		    }
				}
			);
            ModAPI.Register(
                new Modification()
                {
                    OriginalItem = ModAPI.FindSpawnable("Human"),
                    NameOverride = ModTag + "Glimpse",
                    DescriptionOverride = "Activating his head will cause a blackout and skip greatly into the future",
                    CategoryOverride = ModAPI.FindCategory("Zuccians SuperHumans"),
                    ThumbnailOverride = ModAPI.LoadSprite("glit.png"),
                    AfterSpawn = (Instance) =>
                    {
                        var skin = ModAPI.LoadTexture("Glimpse.png");
                        var flesh = ModAPI.LoadTexture("flesh layer.png");
                        var bone = ModAPI.LoadTexture("bone layer.png");

                        var person = Instance.GetComponent<PersonBehaviour>();

                        var head = Instance.transform.Find("Head");

                        head.gameObject.AddComponent<Glimpse>();
                         

                        foreach (var body in person.Limbs)
                        {
                  body.BaseStrength += 4.5f;
                  body.Health *= 80f;
                  body.InitialHealth *= 80f;
                  body.ShotDamageMultiplier *= 0.1f;
                  body.BreakingThreshold += 11f;
                  body.RegenerationSpeed += 30f;
                  body.Vitality *= 50f;
                  body.ImpactPainMultiplier *= 0.1f;
                  body.Numbness *= 1f;
                  body.CirculationBehaviour.BloodFlow *= 3000f;
                  body.IsLethalToBreak = false;
                        }

                        person.SetBodyTextures(skin, flesh, bone, 1);


          		    }
				}
			);
            ModAPI.Register(
                new Modification()
                {
                    OriginalItem = ModAPI.FindSpawnable("Human"),
                    NameOverride = ModTag + "Snap",
                    DescriptionOverride = "Launches his hands off as a weapon by activating them",
                    CategoryOverride = ModAPI.FindCategory("Zuccians SuperHumans"),
                    ThumbnailOverride = ModAPI.LoadSprite("snat.png"),
                    AfterSpawn = (Instance) =>
                    {
                        var skin = ModAPI.LoadTexture("Snap.png");
                        var flesh = ModAPI.LoadTexture("flesh layer.png");
                        var bone = ModAPI.LoadTexture("bone layer.png");

                        var person = Instance.GetComponent<PersonBehaviour>();

                        var arm1 = Instance.transform.Find("FrontArm").Find("LowerArmFront");
                        var arm2 = Instance.transform.Find("BackArm").Find("LowerArm");

                        arm1.gameObject.AddComponent<Snap>();
                        arm2.gameObject.AddComponent<Snap>();

                        foreach (var body in person.Limbs)
                        {
                  body.BaseStrength += 4.5f;
                  body.Health *= 80f;
                  body.InitialHealth *= 80f;
                  body.ShotDamageMultiplier *= 0.1f;
                  body.BreakingThreshold += 11f;
                  body.RegenerationSpeed += 30f;
                  body.Vitality *= 50f;
                  body.ImpactPainMultiplier *= 0.1f;
                  body.Numbness *= 1f;
                  body.CirculationBehaviour.BloodFlow *= 3000f;
                  body.IsLethalToBreak = false;
                        }

                        person.SetBodyTextures(skin, flesh, bone, 1);


          		    }
				}
			);
        }
    }
    public class h : MonoBehaviour
    {

    }
    public class HoseTank : MonoBehaviour
    {
        public GameObject hose1;
        public GameObject hose2;
        public GameObject human;
        public LiquidContainerController LiquidContainer;
        public bool Acidic = true;
        public bool Injure = false;
        public bool Heal = false;
        public bool Syringe = false;

        public void Start()
        {
            this.gameObject.GetComponent<SpriteRenderer>().color = new Color(0f, 1f, 0.4f);
                   hose1.GetComponent<SpriteRenderer>().color = new Color(0f, 1f, 0.4f);
                   hose2.GetComponent<SpriteRenderer>().color = new Color(0f, 1f, 0.4f);
                   foreach (var limbs in human.gameObject.transform.root.gameObject.GetComponent<PersonBehaviour>().Limbs)
                        {
                            limbs.GetComponent<SpriteRenderer>().color = new Color(0f, 1f, 0.4f);
                        }
            this.gameObject.GetComponent<PhysicalBehaviour>().ContextMenuOptions.Buttons.Add(new ContextMenuButton("acid", "Set Liquid To Acid", "Changes the liquid to one that will do acid damage", new UnityAction[1]
            {
                (UnityAction) (() =>
                {
                    this.gameObject.GetComponent<SpriteRenderer>().color = new Color(0f, 1f, 0.4f);
                   hose1.GetComponent<SpriteRenderer>().color = new Color(0f, 1f, 0.4f);
                   hose2.GetComponent<SpriteRenderer>().color = new Color(0f, 1f, 0.4f);
                   foreach (var limbs in human.gameObject.transform.root.gameObject.GetComponent<PersonBehaviour>().Limbs)
                        {
                            limbs.GetComponent<SpriteRenderer>().color = new Color(0f, 1f, 0.4f);
                        }
                   hose2.GetComponent<Hose>().Acidic = true;
                   hose2.GetComponent<Hose>().Injure = false;
                   hose2.GetComponent<Hose>().Heal = false;
                   hose2.GetComponent<Hose>().Syringe = false;
                   hose1.GetComponent<Hose>().Acidic = true;
                   hose1.GetComponent<Hose>().Injure = false;
                   hose1.GetComponent<Hose>().Heal = false;
                   hose1.GetComponent<Hose>().Syringe = false;
                   this.Acidic = true;
                   this.Injure = false;
                   this.Heal = false;
                   this.Syringe = false;
                })
            }));
            this.gameObject.GetComponent<PhysicalBehaviour>().ContextMenuOptions.Buttons.Add(new ContextMenuButton("injure", "Set Liquid To Injure", "Changes the liquid to one that will do damage but not acidic damage", new UnityAction[1]
            {
                (UnityAction) (() =>
                {
                    this.gameObject.GetComponent<SpriteRenderer>().color = new Color(1f, 0f, 0f);
                   hose1.GetComponent<SpriteRenderer>().color = new Color(1f, 0f, 0f);
                   hose2.GetComponent<SpriteRenderer>().color = new Color(1f, 0f, 0f);
                   foreach (var limbs in human.gameObject.transform.root.gameObject.GetComponent<PersonBehaviour>().Limbs)
                        {
                            limbs.GetComponent<SpriteRenderer>().color = new Color(1f, 0f, 0f);
                        }
                   hose2.GetComponent<Hose>().Acidic = false;
                   hose2.GetComponent<Hose>().Injure = true;
                   hose2.GetComponent<Hose>().Heal = false;
                   hose2.GetComponent<Hose>().Syringe = false;
                   hose1.GetComponent<Hose>().Acidic = false;
                   hose1.GetComponent<Hose>().Injure = true;
                   hose1.GetComponent<Hose>().Heal = false;
                   hose1.GetComponent<Hose>().Syringe = false;
                   this.Acidic = false;
                   this.Injure = true;
                   this.Heal = false;
                   this.Syringe = false;
                })
            }));
            this.gameObject.GetComponent<PhysicalBehaviour>().ContextMenuOptions.Buttons.Add(new ContextMenuButton("heal", "Set Liquid To Bullet", "Changes the liquid to one that will move extremely fast", new UnityAction[1]
            {
                (UnityAction) (() =>
                {
                    this.gameObject.GetComponent<SpriteRenderer>().color = new Color(1f, 1f, 0f);
                   hose1.GetComponent<SpriteRenderer>().color = new Color(1f, 1f, 0f);
                   hose2.GetComponent<SpriteRenderer>().color = new Color(1f, 1f, 0f);
                   foreach (var limbs in human.gameObject.transform.root.gameObject.GetComponent<PersonBehaviour>().Limbs)
                        {
                            limbs.GetComponent<SpriteRenderer>().color = new Color(1f, 1f, 0f);
                        }
                   hose2.GetComponent<Hose>().Acidic = false;
                   hose2.GetComponent<Hose>().Injure = false;
                   hose2.GetComponent<Hose>().Heal = true;
                   hose2.GetComponent<Hose>().Syringe = false;
                   hose1.GetComponent<Hose>().Acidic = false;
                   hose1.GetComponent<Hose>().Injure = false;
                   hose1.GetComponent<Hose>().Heal = true;
                   hose1.GetComponent<Hose>().Syringe = false;
                   this.Acidic = false;
                   this.Injure = false;
                   this.Heal = true;
                   this.Syringe = false;
                })
            }));
            this.gameObject.GetComponent<PhysicalBehaviour>().ContextMenuOptions.Buttons.Add(new ContextMenuButton("syringe", "Set Liquid To Syringe Input", "Changes the liquid to whatever is being inputed into the tank", new UnityAction[1]
            {
                (UnityAction) (() =>
                {
                    this.gameObject.GetComponent<SpriteRenderer>().color = this.gameObject.GetComponent<FlaskBehaviour>().GetComputedColor();
                   hose1.GetComponent<SpriteRenderer>().color = this.gameObject.GetComponent<FlaskBehaviour>().GetComputedColor();
                   hose2.GetComponent<SpriteRenderer>().color = this.gameObject.GetComponent<FlaskBehaviour>().GetComputedColor();
                   foreach (var limbs in human.gameObject.transform.root.gameObject.GetComponent<PersonBehaviour>().Limbs)
                        {
                            limbs.GetComponent<SpriteRenderer>().color = this.gameObject.GetComponent<FlaskBehaviour>().GetComputedColor();
                        }
                   hose2.GetComponent<Hose>().Acidic = false;
                   hose2.GetComponent<Hose>().Injure = false;
                   hose2.GetComponent<Hose>().Heal = false;
                   hose2.GetComponent<Hose>().Syringe = true;
                   hose1.GetComponent<Hose>().Acidic = false;
                   hose1.GetComponent<Hose>().Injure = false;
                   hose1.GetComponent<Hose>().Heal = false;
                   hose1.GetComponent<Hose>().Syringe = true;
                   this.Acidic = false;
                   this.Injure = false;
                   this.Heal = false;
                   this.Syringe = true;
                })
            }));
    }

    public void Update()
    {
        if (Syringe)
        {
            string name = "empty";
                  if (this.gameObject.GetComponent<FlaskBehaviour>().GetComponent<BloodContainer>().LiquidDistribution.Count > 0)
                  name = this.gameObject.GetComponent<FlaskBehaviour>().GetComponent<BloodContainer>().LiquidDistribution.First().Key.GetDisplayName();
                  //ModAPI.Notify(name);
            this.gameObject.GetComponent<SpriteRenderer>().color = this.gameObject.GetComponent<FlaskBehaviour>().GetComputedColor();
                   hose1.GetComponent<SpriteRenderer>().color = this.gameObject.GetComponent<FlaskBehaviour>().GetComputedColor();
                   hose2.GetComponent<SpriteRenderer>().color = this.gameObject.GetComponent<FlaskBehaviour>().GetComputedColor();
                   foreach (var limbs in human.gameObject.transform.root.gameObject.GetComponent<PersonBehaviour>().Limbs)
                        {
                            limbs.GetComponent<SpriteRenderer>().color = this.gameObject.GetComponent<FlaskBehaviour>().GetComputedColor();
                        }
        }
    }
    }
    public class Hose : MonoBehaviour
	{
		public Vector2 barrelPosition = new Vector2(0.2f, 0.8f);
		public Vector2 barrelDirection = new Vector2(0f, -0.12f);
        public GameObject mrkrinkle;
        public bool Acidic = true;
        public bool Injure = false;
        public bool Heal = false;
        public bool Syringe = false;

        public void Start()
        { 

        }

		///private Vector2 firstVector;
		///private Rigidbody2D firstRB;

		public void ShootAcid(Vector3 direction, float force, Vector3 pos)
		{
			var project = ModAPI.FindSpawnable("Gorse").Prefab.GetComponentInChildren<GorseDroolingBehaviour>();
    GameObject saliva = UnityEngine.Object.Instantiate<GameObject>(project.Projectile, pos, Quaternion.identity);
    saliva.GetComponent<Rigidbody2D>().AddForce(direction * force, ForceMode2D.Impulse);
    saliva.GetComponent<Rigidbody2D>().gravityScale = 1f;
saliva.GetComponent<Rigidbody2D>().simulated = true;
    var gpb = saliva.GetComponent<GorseProjectileBehaviour>();
    if (Acidic)
    {
gpb.AcidChance = 20;
gpb.Damage = 10;
this.barrelDirection = new Vector2(0f, -0.12f);
    }
    else
    {
        if (Injure)
        {
         gpb.Damage = 30;
         gpb.AcidChance = 0;
         this.barrelDirection = new Vector2(0f, -0.12f);
        }
        else
        {
            if (Heal)
            {
            gpb.Damage = 10;
         gpb.AcidChance = 0;
         this.barrelDirection = new Vector2(0f, -1f);
            }
            else
            {
                gpb.Damage = 0;
         gpb.AcidChance = 0;
                this.barrelDirection = new Vector2(0f, -0.12f);
            }
        }
    }
    var dfugh = gpb.DisperseEffect.GetComponent<AudioSource>();
    var d1 = gpb.DisperseEffect.transform.Find("Debris");
    var guh = gpb.DisperseEffect.transform.Find("extraDecals");
    var d2 = gpb.DisperseEffect.transform.Find("Debris 2");
      var huh = guh.gameObject.GetComponent<FancyBloodSplatController>();
    Destroy(dfugh);
    d1.gameObject.SetActive(false);
    huh.gameObject.SetActive(false);
    d2.gameObject.SetActive(false);
    if (Acidic)
    {
saliva.GetComponent<ParticleSystem>().startColor = new Color(0f, 1f, 0.4f);
    }
    else
    {
        if (Injure)
        {
         saliva.GetComponent<ParticleSystem>().startColor = new Color(1f, 0f, 0f);
        }
        else
        {
            if (Heal)
            {
            saliva.GetComponent<ParticleSystem>().startColor = new Color(1f, 1f, 0f);
            }
            else
            {
                saliva.GetComponent<ParticleSystem>().startColor = this.gameObject.GetComponent<SpriteRenderer>().color;
            }
        }
    }
    var bawl = saliva.transform.Find("GameObject");
    bawl.GetComponent<SpriteRenderer>().color = Color.clear;
    foreach (var limbs in mrkrinkle.transform.root.gameObject.GetComponent<PersonBehaviour>().Limbs)
                        {
                        var Poop = limbs.gameObject.AddComponent<NoCollide>();
                        Poop.NoCollideSetA = saliva.gameObject.GetComponentsInChildren<Collider2D>();
                        Poop.NoCollideSetB = limbs.gameObject.GetComponentsInChildren<Collider2D>();
                        }
    Physics2D.IgnoreCollision(gameObject.GetComponent<Collider2D>(), saliva.GetComponent<Collider2D>());
		}

		public Vector2 BarrelDirection
		{
			get
			{
				return transform.TransformDirection((barrelDirection.x) * transform.localScale.x, (barrelDirection.y), transform.localPosition.z);
			}
		}

		public void UseContinuous()
		{
                  Shoot();
		}

		void Shoot()
		{
                ShootAcid(BarrelDirection, 5f, gameObject.transform.position);
		}
	}
    public class Water : MonoBehaviour
	{
		public Vector2 barrelPosition = new Vector2(0.2f, 0.8f);
		public Vector2 barrelDirection = new Vector2(0f, -0.12f);
        public GameObject mrkrinkle;
        public GameObject armthing;
        float speed = 40f;
        public bool Enabled = false;

        public void Start()
        { 
           armthing.gameObject.AddComponent<UseEventTrigger>().Action = () =>
                {
                    ModAPI.CreateParticleEffect("Spark", armthing.transform.position);
                    if (!Enabled)
                    {
                    this.Enabled = true;
                    foreach (var item in GameObject.FindObjectsOfType<GorseProjectileBehaviour>())
                    {
                        if (item.gameObject.name == "waterdrop")
                        {
                            item.gameObject.GetComponent<ParticleSystem>().startColor = Color.clear;
                        }
                    }
                    }
                    else
                    {
                        foreach (var item in GameObject.FindObjectsOfType<GorseProjectileBehaviour>())
                    {
                        if (item.gameObject.name == "waterdrop")
                        {
                            item.gameObject.GetComponent<Rigidbody2D>().velocity = item.gameObject.GetComponent<Rigidbody2D>().velocity * 0f;
                            item.gameObject.GetComponent<ParticleSystem>().startColor = new Color(0f, 0.5f, 1f);
                          item.gameObject.GetComponent<Rigidbody2D>().velocity = this.gameObject.GetComponent<Rigidbody2D>().velocity * 8f;
                            }
                        }
                    this.Enabled = false;
                    }
                };
        }

		///private Vector2 firstVector;
		///private Rigidbody2D firstRB;

		public void ShootAcid(Vector3 direction, float force, Vector3 pos)
		{
			var project = ModAPI.FindSpawnable("Gorse").Prefab.GetComponentInChildren<GorseDroolingBehaviour>();
    GameObject saliva = UnityEngine.Object.Instantiate<GameObject>(project.Projectile, pos, Quaternion.identity);
    saliva.gameObject.name = "waterdrop";
    if (!Enabled)
    {
    saliva.GetComponent<Rigidbody2D>().AddForce(direction * force, ForceMode2D.Impulse);
    }
    saliva.GetComponent<Rigidbody2D>().gravityScale = 1f;
saliva.GetComponent<Rigidbody2D>().simulated = true;
    var gpb = saliva.GetComponent<GorseProjectileBehaviour>();
                gpb.Damage = 0;
         gpb.AcidChance = 0;
    var dfugh = gpb.DisperseEffect.GetComponent<AudioSource>();
    var d1 = gpb.DisperseEffect.transform.Find("Debris");
    var guh = gpb.DisperseEffect.transform.Find("extraDecals");
    var d2 = gpb.DisperseEffect.transform.Find("Debris 2");
      var huh = guh.gameObject.GetComponent<FancyBloodSplatController>();
    Destroy(dfugh);
    d1.gameObject.SetActive(false);
    huh.gameObject.SetActive(false);
    d2.gameObject.SetActive(false);
if (!Enabled)
    {
saliva.GetComponent<ParticleSystem>().startColor = new Color(0f, 0.5f, 1f);
    }
    else
    {
        saliva.GetComponent<ParticleSystem>().startColor = Color.clear;
    }
    var bawl = saliva.transform.Find("GameObject");
    bawl.GetComponent<SpriteRenderer>().color = new Color(0f, 0.5f, 1f);
    foreach (var limbs in mrkrinkle.transform.root.gameObject.GetComponent<PersonBehaviour>().Limbs)
                        {
                        var Poop = limbs.gameObject.AddComponent<NoCollide>();
                        Poop.NoCollideSetA = saliva.gameObject.GetComponentsInChildren<Collider2D>();
                        Poop.NoCollideSetB = limbs.gameObject.GetComponentsInChildren<Collider2D>();
                        }
    Physics2D.IgnoreCollision(gameObject.GetComponent<Collider2D>(), saliva.GetComponent<Collider2D>());
		}

		public Vector2 BarrelDirection
		{
			get
			{
				return transform.TransformDirection((barrelDirection.x) * transform.localScale.x, (barrelDirection.y), transform.localPosition.z);
			}
		}

        public void Update()
        {
          if (Enabled)
          {
                              foreach (var item in GameObject.FindObjectsOfType<GorseProjectileBehaviour>())
                    {
                        if (item.gameObject.name == "waterdrop")
                        {
                          item.transform.position = armthing.gameObject.transform.position;
                          item.transform.rotation = armthing.gameObject.transform.rotation;
                            }
                        }
          }
        }

		public void UseContinuous()
		{
                  Shoot();
		}

		void Shoot()
		{
                ShootAcid(BarrelDirection, 5f, gameObject.transform.position);
		}
	}
    public class Fire : MonoBehaviour
	{
		public Vector2 barrelPosition = new Vector2(0.2f, 0.8f);
		public Vector2 barrelDirection = new Vector2(0f, -0.12f);
        public GameObject mrkrinkle;
        public GameObject armthing;
        float speed = 40f;
        public bool Enabled = false;

        public void Start()
        { 
           armthing.gameObject.AddComponent<UseEventTrigger>().Action = () =>
                {
                    ModAPI.CreateParticleEffect("Spark", armthing.transform.position);
                    if (!Enabled)
                    {
                    this.Enabled = true;
                    foreach (var item in GameObject.FindObjectsOfType<GorseProjectileBehaviour>())
                    {
                        if (item.gameObject.name == "firedrop")
                        {
                            item.gameObject.GetComponent<ParticleSystem>().startColor = Color.clear;
                        }
                    }
                    }
                    else
                    {
                        foreach (var item in GameObject.FindObjectsOfType<GorseProjectileBehaviour>())
                    {
                        if (item.gameObject.name == "firedrop")
                        {
                            item.gameObject.GetComponent<Rigidbody2D>().velocity = item.gameObject.GetComponent<Rigidbody2D>().velocity * 0f;
                            item.gameObject.GetComponent<ParticleSystem>().startColor = new Color(1f, 0.4f, 0f);
                          item.gameObject.GetComponent<Rigidbody2D>().velocity = this.gameObject.GetComponent<Rigidbody2D>().velocity * 8f;
                            }
                        }
                    this.Enabled = false;
                    }
                };
        }

		///private Vector2 firstVector;
		///private Rigidbody2D firstRB;

		public void ShootAcid(Vector3 direction, float force, Vector3 pos)
		{
			var project = ModAPI.FindSpawnable("Gorse").Prefab.GetComponentInChildren<GorseDroolingBehaviour>();
    GameObject saliva = UnityEngine.Object.Instantiate<GameObject>(project.Projectile, pos, Quaternion.identity);
    saliva.gameObject.name = "firedrop";
    if (!Enabled)
    {
    saliva.GetComponent<Rigidbody2D>().AddForce(direction * force, ForceMode2D.Impulse);
    }
    saliva.GetComponent<Rigidbody2D>().gravityScale = 1f;
saliva.GetComponent<Rigidbody2D>().simulated = true;
    var gpb = saliva.GetComponent<GorseProjectileBehaviour>();
                gpb.Damage = 0;
         gpb.AcidChance = 0;
    var dfugh = gpb.DisperseEffect.GetComponent<AudioSource>();
    var d1 = gpb.DisperseEffect.transform.Find("Debris");
    var guh = gpb.DisperseEffect.transform.Find("extraDecals");
    var d2 = gpb.DisperseEffect.transform.Find("Debris 2");
      var huh = guh.gameObject.GetComponent<FancyBloodSplatController>();
    Destroy(dfugh);
    d1.gameObject.SetActive(false);
    huh.gameObject.SetActive(false);
    d2.gameObject.SetActive(false);
    if (!Enabled)
    {
saliva.GetComponent<ParticleSystem>().startColor = new Color(1f, 0.4f, 0f);
    }
    else
    {
        saliva.GetComponent<ParticleSystem>().startColor = Color.clear;
    }
    var bawl = saliva.transform.Find("GameObject");
    bawl.GetComponent<SpriteRenderer>().color = new Color(1f, 0.4f, 0f);
    bawl.GetComponent<SpriteRenderer>().material = ModAPI.FindMaterial("VeryBright");
    foreach (var limbs in mrkrinkle.transform.root.gameObject.GetComponent<PersonBehaviour>().Limbs)
                        {
                        var Poop = limbs.gameObject.AddComponent<NoCollide>();
                        Poop.NoCollideSetA = saliva.gameObject.GetComponentsInChildren<Collider2D>();
                        Poop.NoCollideSetB = limbs.gameObject.GetComponentsInChildren<Collider2D>();
                        }
    Physics2D.IgnoreCollision(gameObject.GetComponent<Collider2D>(), saliva.GetComponent<Collider2D>());
		}

		public Vector2 BarrelDirection
		{
			get
			{
				return transform.TransformDirection((barrelDirection.x) * transform.localScale.x, (barrelDirection.y), transform.localPosition.z);
			}
		}

        public void Update()
        {
          if (Enabled)
          {
                              foreach (var item in GameObject.FindObjectsOfType<GorseProjectileBehaviour>())
                    {
                        if (item.gameObject.name == "firedrop")
                        {
                          item.transform.position = armthing.gameObject.transform.position;
                          item.transform.rotation = armthing.gameObject.transform.rotation;
                            }
                        }
          }
        }

		public void UseContinuous()
		{
                  Shoot();
		}

		void Shoot()
		{
                ShootAcid(BarrelDirection, 5f, gameObject.transform.position);
		}
	}
    public class Snap : MonoBehaviour
    {
        public bool Enabled = false;
        public void Use()
        {
            if (!Enabled)
            {
                this.Enabled = true;
            ModAPI.CreateParticleEffect("Spark", this.transform.position);
            ModAPI.CreateParticleEffect("Ricochet", this.transform.position);
            Destroy(this.gameObject.GetComponent<HingeJoint2D>());
            Destroy(this.gameObject.GetComponent<LimbBehaviour>());
            this.gameObject.GetComponent<Rigidbody2D>().AddForce(-this.transform.up * 4f, ForceMode2D.Impulse);
           // DistanceJoint2D joint = this.gameObject.AddComponent<DistanceJoint2D>();
                   // joint.maxDistanceOnly = true;
                   // joint.enableCollision = true;
                    //joint.distance = 150f;
                    //joint.autoConfigureDistance = true;
                    //joint.breakForce = Mathf.Infinity;
                   // joint.breakTorque = Mathf.Infinity;

                    //joint.connectedBody = this.gameObject.transform.root.gameObject.GetComponent<PersonBehaviour>().Limbs[1].gameObject.GetComponent<Rigidbody2D>();

                   // joint.connectedAnchor = this.gameObject.transform.root.gameObject.GetComponent<PersonBehaviour>().Limbs[1].gameObject.transform.position;

                    //JointCreated(joint);
        }
        }
        void JointCreated(DistanceJoint2D joint)
        {
            EnergyWireBehaviour energyWireBehaviour = joint.gameObject.AddComponent<EnergyWireBehaviour>();
            energyWireBehaviour.WireColor = new Color(1f, 0f, 1f);
            energyWireBehaviour.WireMaterial = Resources.Load<Material>("Materials/Wire");
            energyWireBehaviour.WireWidth = 0.021f;
            energyWireBehaviour.typedJoint = joint;
        }
        
    }
    public class Erasure : MonoBehaviour
    {

        public AudioClip skip = ModAPI.LoadSound("skip.wav");
        AudioSource auds;
       public LightSprite ScreenLight;
        
        public void Start()
        {
            ScreenLight = ModAPI.CreateLight(transform, new Color(1f, 0.5f, 0.5f, 1));
        ScreenLight.Brightness = 0f;
        ScreenLight.Radius = 9999999f;
        ScreenLight.transform.SetParent(this.gameObject.transform);
            GameObject audsGO = new GameObject();
            audsGO.transform.SetParent(gameObject.transform, false);
            auds = audsGO.AddComponent<AudioSource>();
            auds.spatialBlend = 1;
            GameObject.FindObjectOfType<Global>().AddAudioSource(auds, false);
            auds.gameObject.AddComponent<AudioDistortionFilter>().distortionLevel = 0.77f;
            auds.outputAudioMixerGroup = GameObject.FindObjectOfType<Global>().SoundEffects;
            auds.volume = 1;
        }

        public void Use()
         {
        StartCoroutine(RRRRRRR());
            Time.timeScale = 12;
            auds.PlayOneShot(skip);
            foreach (var item in GameObject.FindObjectsOfType<PhysicalBehaviour>())
                    {
                        ModAPI.CreateParticleEffect("Vapor", item.gameObject.transform.position);
                    }
        }

        public IEnumerator RRRRRRR() 
        {
            ScreenLight.Brightness = 20f;
            yield return new WaitForSeconds(0.6f);
             ScreenLight.Brightness = 0f;
        }
    }
    public class Glimpse : MonoBehaviour
    {

        public AudioClip skip = ModAPI.LoadSound("skip2.wav");
        AudioSource auds;
       public LightSprite ScreenLight;
        
        public void Start()
        {
            ScreenLight = ModAPI.CreateLight(transform, new Color(1f, 1f, 1f, 1));
        ScreenLight.Brightness = 0f;
        ScreenLight.Radius = 9999999f;
        ScreenLight.transform.SetParent(this.gameObject.transform);
            GameObject audsGO = new GameObject();
            audsGO.transform.SetParent(gameObject.transform, false);
            auds = audsGO.AddComponent<AudioSource>();
            auds.spatialBlend = 1;
            GameObject.FindObjectOfType<Global>().AddAudioSource(auds, false);
            auds.gameObject.AddComponent<AudioDistortionFilter>().distortionLevel = 0.77f;
            auds.outputAudioMixerGroup = GameObject.FindObjectOfType<Global>().SoundEffects;
            auds.volume = 1;
        }

        public void Use()
         {
        StartCoroutine(RRRRRRR());
            Time.timeScale = 120;
            auds.PlayOneShot(skip);
            foreach (var item in GameObject.FindObjectsOfType<PhysicalBehaviour>())
                    {
                        ModAPI.CreateParticleEffect("Vapor", item.gameObject.transform.position);
                    }
        }

        public IEnumerator RRRRRRR() 
        {
            ScreenLight.Brightness = -50000f;
            yield return new WaitForSeconds(10f);
             ScreenLight.Brightness = 0f;
        }
    }
    public class s : MonoBehaviour
    {
       public GameObject thing;

       public void Use()
       {
           ModAPI.CreateParticleEffect("HugeZap", this.transform.position);
        this.gameObject.transform.root.gameObject.GetComponent<PersonBehaviour>().Limbs[0].gameObject.transform.position = this.thing.gameObject.GetComponent<PersonBehaviour>().Limbs[0].gameObject.transform.position;
                    this.gameObject.transform.root.gameObject.GetComponent<PersonBehaviour>().Limbs[0].gameObject.transform.rotation = this.thing.gameObject.GetComponent<PersonBehaviour>().Limbs[0].gameObject.transform.rotation;
                    this.gameObject.transform.root.gameObject.GetComponent<PersonBehaviour>().Limbs[1].gameObject.transform.position = this.thing.gameObject.GetComponent<PersonBehaviour>().Limbs[1].gameObject.transform.position;
                    this.gameObject.transform.root.gameObject.GetComponent<PersonBehaviour>().Limbs[1].gameObject.transform.rotation = this.thing.gameObject.GetComponent<PersonBehaviour>().Limbs[1].gameObject.transform.rotation;
                    this.gameObject.transform.root.gameObject.GetComponent<PersonBehaviour>().Limbs[2].gameObject.transform.position = this.thing.gameObject.GetComponent<PersonBehaviour>().Limbs[2].gameObject.transform.position;
                    this.gameObject.transform.root.gameObject.GetComponent<PersonBehaviour>().Limbs[2].gameObject.transform.rotation = this.thing.gameObject.GetComponent<PersonBehaviour>().Limbs[2].gameObject.transform.rotation;
                    this.gameObject.transform.root.gameObject.GetComponent<PersonBehaviour>().Limbs[3].gameObject.transform.position = this.thing.gameObject.GetComponent<PersonBehaviour>().Limbs[3].gameObject.transform.position;
                    this.gameObject.transform.root.gameObject.GetComponent<PersonBehaviour>().Limbs[3].gameObject.transform.rotation = this.thing.gameObject.GetComponent<PersonBehaviour>().Limbs[3].gameObject.transform.rotation;
                    this.gameObject.transform.root.gameObject.GetComponent<PersonBehaviour>().Limbs[4].gameObject.transform.position = this.thing.gameObject.GetComponent<PersonBehaviour>().Limbs[4].gameObject.transform.position;
                    this.gameObject.transform.root.gameObject.GetComponent<PersonBehaviour>().Limbs[4].gameObject.transform.rotation = this.thing.gameObject.GetComponent<PersonBehaviour>().Limbs[4].gameObject.transform.rotation;
                    this.gameObject.transform.root.gameObject.GetComponent<PersonBehaviour>().Limbs[5].gameObject.transform.position = this.thing.gameObject.GetComponent<PersonBehaviour>().Limbs[5].gameObject.transform.position;
                    this.gameObject.transform.root.gameObject.GetComponent<PersonBehaviour>().Limbs[5].gameObject.transform.rotation = this.thing.gameObject.GetComponent<PersonBehaviour>().Limbs[5].gameObject.transform.rotation;
                    this.gameObject.transform.root.gameObject.GetComponent<PersonBehaviour>().Limbs[6].gameObject.transform.position = this.thing.gameObject.GetComponent<PersonBehaviour>().Limbs[6].gameObject.transform.position;
                    this.gameObject.transform.root.gameObject.GetComponent<PersonBehaviour>().Limbs[6].gameObject.transform.rotation = this.thing.gameObject.GetComponent<PersonBehaviour>().Limbs[6].gameObject.transform.rotation;
                    this.gameObject.transform.root.gameObject.GetComponent<PersonBehaviour>().Limbs[7].gameObject.transform.position = this.thing.gameObject.GetComponent<PersonBehaviour>().Limbs[7].gameObject.transform.position;
                    this.gameObject.transform.root.gameObject.GetComponent<PersonBehaviour>().Limbs[7].gameObject.transform.rotation = this.thing.gameObject.GetComponent<PersonBehaviour>().Limbs[7].gameObject.transform.rotation;
                    this.gameObject.transform.root.gameObject.GetComponent<PersonBehaviour>().Limbs[8].gameObject.transform.position = this.thing.gameObject.GetComponent<PersonBehaviour>().Limbs[8].gameObject.transform.position;
                    this.gameObject.transform.root.gameObject.GetComponent<PersonBehaviour>().Limbs[8].gameObject.transform.rotation = this.thing.gameObject.GetComponent<PersonBehaviour>().Limbs[8].gameObject.transform.rotation;
                    this.gameObject.transform.root.gameObject.GetComponent<PersonBehaviour>().Limbs[9].gameObject.transform.position = this.thing.gameObject.GetComponent<PersonBehaviour>().Limbs[9].gameObject.transform.position;
                    this.gameObject.transform.root.gameObject.GetComponent<PersonBehaviour>().Limbs[9].gameObject.transform.rotation = this.thing.gameObject.GetComponent<PersonBehaviour>().Limbs[9].gameObject.transform.rotation;
                    this.gameObject.transform.root.gameObject.GetComponent<PersonBehaviour>().Limbs[10].gameObject.transform.position = this.thing.gameObject.GetComponent<PersonBehaviour>().Limbs[10].gameObject.transform.position;
                    this.gameObject.transform.root.gameObject.GetComponent<PersonBehaviour>().Limbs[10].gameObject.transform.rotation = this.thing.gameObject.GetComponent<PersonBehaviour>().Limbs[10].gameObject.transform.rotation;
                    this.gameObject.transform.root.gameObject.GetComponent<PersonBehaviour>().Limbs[11].gameObject.transform.position = this.thing.gameObject.GetComponent<PersonBehaviour>().Limbs[11].gameObject.transform.position;
                    this.gameObject.transform.root.gameObject.GetComponent<PersonBehaviour>().Limbs[11].gameObject.transform.rotation = this.thing.gameObject.GetComponent<PersonBehaviour>().Limbs[11].gameObject.transform.rotation;
                    this.gameObject.transform.root.gameObject.GetComponent<PersonBehaviour>().Limbs[12].gameObject.transform.position = this.thing.gameObject.GetComponent<PersonBehaviour>().Limbs[12].gameObject.transform.position;
                    this.gameObject.transform.root.gameObject.GetComponent<PersonBehaviour>().Limbs[12].gameObject.transform.rotation = this.thing.gameObject.GetComponent<PersonBehaviour>().Limbs[12].gameObject.transform.rotation;
                    this.gameObject.transform.root.gameObject.GetComponent<PersonBehaviour>().Limbs[13].gameObject.transform.position = this.thing.gameObject.GetComponent<PersonBehaviour>().Limbs[13].gameObject.transform.position;
                    this.gameObject.transform.root.gameObject.GetComponent<PersonBehaviour>().Limbs[13].gameObject.transform.rotation = this.thing.gameObject.GetComponent<PersonBehaviour>().Limbs[13].gameObject.transform.rotation;
       }
    }
    //SOMETIMES, WHEN IM LONELY, I SIT AND THINK ABOUT HIM <3
    public class Shade : MonoBehaviour
    {
        public bool Enabled;
        public bool Exists = false;
        public bool q = false;
        public GameObject trancer;

        public void Use()
        {
            if (!Exists)
            {
                this.Exists = true;
            var ha = GameObject.Instantiate(ModAPI.FindSpawnable("shadeclone").Prefab);
            CatalogBehaviour.PerformMod(ModAPI.FindSpawnable("shadeclone"), ha);
            this.trancer = ha.gameObject.transform.root.gameObject;
            this.trancer.gameObject.transform.root.gameObject.transform.position = this.gameObject.transform.root.gameObject.transform.position;
            var g = this.trancer.gameObject.GetComponent<PersonBehaviour>().Limbs[0].gameObject;
            g.gameObject.AddComponent<s>();
            g.gameObject.GetComponent<s>().thing = this.gameObject.transform.root.gameObject;
            foreach (var Limbs in this.trancer.gameObject.transform.root.gameObject.GetComponent<PersonBehaviour>().Limbs)
       {
           foreach (var limbs in trancer.transform.root.gameObject.GetComponent<PersonBehaviour>().Limbs)
                        {
                        limbs.gameObject.layer = 10;
                        limbs.gameObject.GetComponent<SpriteRenderer>().color = new Color(1f, 1f, 1f, 0.8f);
                        }
      }
            }
            else
            {
                if (!q)
                {
                    ModAPI.CreateParticleEffect("HugeZap", this.transform.position);
                    this.gameObject.transform.root.gameObject.GetComponent<PersonBehaviour>().Limbs[0].gameObject.transform.position = this.trancer.gameObject.GetComponent<PersonBehaviour>().Limbs[0].gameObject.transform.position;
                    this.gameObject.transform.root.gameObject.GetComponent<PersonBehaviour>().Limbs[0].gameObject.transform.rotation = this.trancer.gameObject.GetComponent<PersonBehaviour>().Limbs[0].gameObject.transform.rotation;
                    this.gameObject.transform.root.gameObject.GetComponent<PersonBehaviour>().Limbs[1].gameObject.transform.position = this.trancer.gameObject.GetComponent<PersonBehaviour>().Limbs[1].gameObject.transform.position;
                    this.gameObject.transform.root.gameObject.GetComponent<PersonBehaviour>().Limbs[1].gameObject.transform.rotation = this.trancer.gameObject.GetComponent<PersonBehaviour>().Limbs[1].gameObject.transform.rotation;
                    this.gameObject.transform.root.gameObject.GetComponent<PersonBehaviour>().Limbs[2].gameObject.transform.position = this.trancer.gameObject.GetComponent<PersonBehaviour>().Limbs[2].gameObject.transform.position;
                    this.gameObject.transform.root.gameObject.GetComponent<PersonBehaviour>().Limbs[2].gameObject.transform.rotation = this.trancer.gameObject.GetComponent<PersonBehaviour>().Limbs[2].gameObject.transform.rotation;
                    this.gameObject.transform.root.gameObject.GetComponent<PersonBehaviour>().Limbs[3].gameObject.transform.position = this.trancer.gameObject.GetComponent<PersonBehaviour>().Limbs[3].gameObject.transform.position;
                    this.gameObject.transform.root.gameObject.GetComponent<PersonBehaviour>().Limbs[3].gameObject.transform.rotation = this.trancer.gameObject.GetComponent<PersonBehaviour>().Limbs[3].gameObject.transform.rotation;
                    this.gameObject.transform.root.gameObject.GetComponent<PersonBehaviour>().Limbs[4].gameObject.transform.position = this.trancer.gameObject.GetComponent<PersonBehaviour>().Limbs[4].gameObject.transform.position;
                    this.gameObject.transform.root.gameObject.GetComponent<PersonBehaviour>().Limbs[4].gameObject.transform.rotation = this.trancer.gameObject.GetComponent<PersonBehaviour>().Limbs[4].gameObject.transform.rotation;
                    this.gameObject.transform.root.gameObject.GetComponent<PersonBehaviour>().Limbs[5].gameObject.transform.position = this.trancer.gameObject.GetComponent<PersonBehaviour>().Limbs[5].gameObject.transform.position;
                    this.gameObject.transform.root.gameObject.GetComponent<PersonBehaviour>().Limbs[5].gameObject.transform.rotation = this.trancer.gameObject.GetComponent<PersonBehaviour>().Limbs[5].gameObject.transform.rotation;
                    this.gameObject.transform.root.gameObject.GetComponent<PersonBehaviour>().Limbs[6].gameObject.transform.position = this.trancer.gameObject.GetComponent<PersonBehaviour>().Limbs[6].gameObject.transform.position;
                    this.gameObject.transform.root.gameObject.GetComponent<PersonBehaviour>().Limbs[6].gameObject.transform.rotation = this.trancer.gameObject.GetComponent<PersonBehaviour>().Limbs[6].gameObject.transform.rotation;
                    this.gameObject.transform.root.gameObject.GetComponent<PersonBehaviour>().Limbs[7].gameObject.transform.position = this.trancer.gameObject.GetComponent<PersonBehaviour>().Limbs[7].gameObject.transform.position;
                    this.gameObject.transform.root.gameObject.GetComponent<PersonBehaviour>().Limbs[7].gameObject.transform.rotation = this.trancer.gameObject.GetComponent<PersonBehaviour>().Limbs[7].gameObject.transform.rotation;
                    this.gameObject.transform.root.gameObject.GetComponent<PersonBehaviour>().Limbs[8].gameObject.transform.position = this.trancer.gameObject.GetComponent<PersonBehaviour>().Limbs[8].gameObject.transform.position;
                    this.gameObject.transform.root.gameObject.GetComponent<PersonBehaviour>().Limbs[8].gameObject.transform.rotation = this.trancer.gameObject.GetComponent<PersonBehaviour>().Limbs[8].gameObject.transform.rotation;
                    this.gameObject.transform.root.gameObject.GetComponent<PersonBehaviour>().Limbs[9].gameObject.transform.position = this.trancer.gameObject.GetComponent<PersonBehaviour>().Limbs[9].gameObject.transform.position;
                    this.gameObject.transform.root.gameObject.GetComponent<PersonBehaviour>().Limbs[9].gameObject.transform.rotation = this.trancer.gameObject.GetComponent<PersonBehaviour>().Limbs[9].gameObject.transform.rotation;
                    this.gameObject.transform.root.gameObject.GetComponent<PersonBehaviour>().Limbs[10].gameObject.transform.position = this.trancer.gameObject.GetComponent<PersonBehaviour>().Limbs[10].gameObject.transform.position;
                    this.gameObject.transform.root.gameObject.GetComponent<PersonBehaviour>().Limbs[10].gameObject.transform.rotation = this.trancer.gameObject.GetComponent<PersonBehaviour>().Limbs[10].gameObject.transform.rotation;
                    this.gameObject.transform.root.gameObject.GetComponent<PersonBehaviour>().Limbs[11].gameObject.transform.position = this.trancer.gameObject.GetComponent<PersonBehaviour>().Limbs[11].gameObject.transform.position;
                    this.gameObject.transform.root.gameObject.GetComponent<PersonBehaviour>().Limbs[11].gameObject.transform.rotation = this.trancer.gameObject.GetComponent<PersonBehaviour>().Limbs[11].gameObject.transform.rotation;
                    this.gameObject.transform.root.gameObject.GetComponent<PersonBehaviour>().Limbs[12].gameObject.transform.position = this.trancer.gameObject.GetComponent<PersonBehaviour>().Limbs[12].gameObject.transform.position;
                    this.gameObject.transform.root.gameObject.GetComponent<PersonBehaviour>().Limbs[12].gameObject.transform.rotation = this.trancer.gameObject.GetComponent<PersonBehaviour>().Limbs[12].gameObject.transform.rotation;
                    this.gameObject.transform.root.gameObject.GetComponent<PersonBehaviour>().Limbs[13].gameObject.transform.position = this.trancer.gameObject.GetComponent<PersonBehaviour>().Limbs[13].gameObject.transform.position;
                    this.gameObject.transform.root.gameObject.GetComponent<PersonBehaviour>().Limbs[13].gameObject.transform.rotation = this.trancer.gameObject.GetComponent<PersonBehaviour>().Limbs[13].gameObject.transform.rotation;
            }
            }
        }
    }
    public class Trance : MonoBehaviour
    {
        public bool Enabled;
        public GameObject trancer;
        public GameObject thing;
        public Sprite glow = ModAPI.LoadSprite("trancething.png");

        public void Start()
        {
         GameObject childObject = new GameObject("Glow2");
        childObject.transform.SetParent(this.gameObject.transform);
        childObject.transform.localPosition = new Vector3(0f, 0f);
        childObject.transform.localScale = new Vector3(1f, 1f);
        var childSprite = childObject.AddComponent<SpriteRenderer>();
        childSprite.sprite = this.glow;
        childSprite.sharedMaterial = ModAPI.FindMaterial("VeryBright");
        childSprite.transform.position = this.transform.position;
        childSprite.transform.rotation = this.transform.rotation;
        childSprite.sortingLayerName = "Top";
        childSprite.color = Color.clear;
        this.thing = childObject;
        
        }

        public void Use()
        {
            if (!Enabled)
            {
                this.Enabled = true;
            this.thing.GetComponent<SpriteRenderer>().color = Color.cyan;
            this.trancer = GameObject.Instantiate(ModAPI.FindSpawnable("Human").Prefab);
            CatalogBehaviour.PerformMod(ModAPI.FindSpawnable("Human"), trancer);
            this.trancer.gameObject.transform.position = this.gameObject.transform.position;
            foreach (var Limbs in this.trancer.gameObject.transform.root.gameObject.GetComponent<PersonBehaviour>().Limbs)
       {
           foreach (var limbs in trancer.transform.root.gameObject.GetComponent<PersonBehaviour>().Limbs)
                        {
                        var Poop = limbs.gameObject.AddComponent<NoCollide>();
                        Poop.NoCollideSetA = this.gameObject.transform.root.gameObject.GetComponentsInChildren<Collider2D>();
                        Poop.NoCollideSetB = limbs.gameObject.GetComponentsInChildren<Collider2D>();
                        }
           Limbs.gameObject.GetComponent<SpriteRenderer>().color = new Color(0f, 1f, 1f, 0.5f);
       }
            }
            else
            {
                this.thing.GetComponent<SpriteRenderer>().color = Color.clear;
                this.Enabled = false;
                Destroy(this.trancer);
            }
        }
    }
    public class Penumbrate : MonoBehaviour
    {

        public AudioClip spooky = ModAPI.LoadSound("spooky.wav");
        AudioSource auds;
        
        public void Start()
        {
            GameObject audsGO = new GameObject();
            audsGO.transform.SetParent(gameObject.transform, false);
            auds = audsGO.AddComponent<AudioSource>();
            auds.spatialBlend = 1;
            GameObject.FindObjectOfType<Global>().AddAudioSource(auds, false);
            auds.gameObject.AddComponent<AudioDistortionFilter>().distortionLevel = 0.77f;
            auds.outputAudioMixerGroup = GameObject.FindObjectOfType<Global>().SoundEffects;
            auds.volume = 1;
        }

        public void Use()
        {
            ModAPI.CreateParticleEffect("Disintegration", this.transform.position);
            auds.PlayOneShot(spooky);
            foreach (var item in GameObject.FindObjectsOfType<PhysicalBehaviour>())
                    {
            if (!item.gameObject.GetComponent<LimbBehaviour>().Person.IsAlive())
            {
                 foreach (var Limbs in item.gameObject.transform.root.gameObject.GetComponent<PersonBehaviour>().Limbs)
       {
           Limbs.CirculationBehaviour.AddLiquid(Liquid.GetLiquid("LIFE SERUM"), 1f);
           Limbs.gameObject.GetComponent<SpriteRenderer>().color = new Color(0.1f, 0.2f, 0.4f);
           ModAPI.CreateParticleEffect("Spark", Limbs.gameObject.transform.position);
       }
            }
            }
        }
    }
    public class Card : MonoBehaviour
    {
        public string StoredObject;
        public bool IsStoring = false;
        public GameObject sads;

        public void Use()
        {
            this.gameObject.layer = 10;
            Destroy(this.gameObject, 0.25f);
            if (!IsStoring)
            {
            }
            else{
                ModAPI.CreateParticleEffect("Spark", this.transform.position);
                this.sads = GameObject.Instantiate(ModAPI.FindSpawnable(StoredObject).Prefab);
                        CatalogBehaviour.PerformMod(ModAPI.FindSpawnable(StoredObject), sads);
                        sads.gameObject.transform.rotation = this.gameObject.transform.rotation;
                        sads.gameObject.transform.position = this.gameObject.transform.position;
                        this.sads.GetComponent<Rigidbody2D>().angularVelocity = this.gameObject.GetComponent<Rigidbody2D>().angularVelocity;
                        this.sads.GetComponent<Rigidbody2D>().velocity = this.gameObject.GetComponent<Rigidbody2D>().velocity;
                        this.sads.name = this.StoredObject;
                this.IsStoring = false;
                this.StoredObject = null;
            }
        }

                public void OnCollisionEnter2D(Collision2D other)
        {
            if (!IsStoring)
            {
                 if (other.gameObject.layer == 9)
                {
                    ModAPI.CreateParticleEffect("Flash", this.transform.position);
                this.StoredObject = other.gameObject.transform.root.gameObject.name;
                this.IsStoring = true;
                Destroy(other.gameObject);
         foreach (Transform child in other.gameObject.transform.root.gameObject.transform)
         {
Destroy(child.gameObject);
         }
                this.sads = null;
                }
            }
            else
            {

            }
        }
    }
    public class Tension : MonoBehaviour
    {
        public bool Enabled = false;
        public Texture2D OgSkin = null;
        public Texture2D OgBones = null;
        public Texture2D OgFlesh = null;
        public Texture2D Skin = null;
        public Texture2D Bones = null;
        public Texture2D Flesh = null;

        public void Start()
        {
            OgSkin = this.gameObject.GetComponent<LimbBehaviour>().SkinMaterialHandler.renderer.sprite.texture;
            OgFlesh = (Texture2D)this.gameObject.GetComponent<LimbBehaviour>().SkinMaterialHandler.renderer.material.GetTexture("_FleshTex");
            OgBones = (Texture2D)this.gameObject.GetComponent<LimbBehaviour>().SkinMaterialHandler.renderer.material.GetTexture("_BoneTex");
        }

        public void Use()
        {
           if (!Enabled)
           {
               ModAPI.CreateParticleEffect("Spark", this.transform.position);
               if (Skin)
               {
                   Enabled = true;
               this.gameObject.GetComponent<LimbBehaviour>().Person.SetBodyTextures(Skin, Skin, OgSkin);
               foreach (var Limbs in this.transform.root.gameObject.GetComponent<PersonBehaviour>().Limbs)
       {
          Limbs.SkinMaterialHandler.AcidProgress = 10f;
          Limbs.Broken = false;
          Limbs.CirculationBehaviour.AddLiquid(Liquid.GetLiquid("LIFE SERUM"), 2f);
          Limbs.gameObject.GetComponent<PhysicalBehaviour>().Properties = ModAPI.FindPhysicalProperties("Human");
       }
           }
           }
           else
           {
               ModAPI.CreateParticleEffect("Spark", this.transform.position);
               Enabled = false;
               this.gameObject.GetComponent<LimbBehaviour>().Person.SetBodyTextures(OgSkin, OgSkin, OgSkin);
               foreach (var Limbs in this.transform.root.gameObject.GetComponent<PersonBehaviour>().Limbs)
       {
          Limbs.Broken = true;
          Limbs.gameObject.GetComponent<PhysicalBehaviour>().Properties = ModAPI.FindPhysicalProperties("Wood");
       }
           }
        }

        public void OnCollisionEnter2D(Collision2D other)
        {
            if (other.gameObject.GetComponent<LimbBehaviour>())
            {
            Skin = other.gameObject.GetComponent<LimbBehaviour>().SkinMaterialHandler.renderer.sprite.texture;
            Flesh = (Texture2D)other.gameObject.GetComponent<LimbBehaviour>().SkinMaterialHandler.renderer.material.GetTexture("_FleshTex");
            Bones = (Texture2D)other.gameObject.GetComponent<LimbBehaviour>().SkinMaterialHandler.renderer.material.GetTexture("_BoneTex");
            }
        }
    }
    public class Lotus : MonoBehaviour
    {
        public GameObject flowerbase = null;

        public void Use()
        {
           if (flowerbase != null)
           {
               ModAPI.CreateParticleEffect("Vapor", this.transform.position);
               flowerbase.gameObject.AddComponent<Blossom>();
               flowerbase = null;
           }
        }

        public void OnCollisionEnter2D(Collision2D other)
        {
            if (other.gameObject.GetComponent<PhysicalBehaviour>() && other.gameObject.layer == 9)
            {
            if (flowerbase != null)
            {
                flowerbase = null;
            }
            flowerbase = other.gameObject;
            }
        }
    }
    public class Blossom : MonoBehaviour
    {
        public void Start()
        {
            GameObject Item3 = GameObject.Instantiate(ModAPI.FindSpawnable("lotusflower").Prefab);
CatalogBehaviour.PerformMod(ModAPI.FindSpawnable("lotusflower"), Item3);
                        Item3.gameObject.GetComponent<SpriteRenderer>().sortingLayerName = "Top";
                        Item3.transform.SetParent(this.transform);
                        Item3.transform.position = this.transform.position;
                        Item3.transform.rotation = this.transform.rotation;
                        Item3.layer = 0;
                        Item3.name = "bloom";
                        if (this.gameObject.GetComponent<LimbBehaviour>())
                        {
                         this.gameObject.AddComponent<die>();
                        }
                        if (this.gameObject.GetComponent<DamagableMachineryBehaviour>())
                        {
                          this.gameObject.AddComponent<machinedie>();
                        }
                        Item3.gameObject.AddComponent<dfd>();
                        Item3.gameObject.GetComponent<dfd>().guh = this.gameObject;
        }
    }
    public class die : MonoBehaviour
    {
        public float SporeAmount = 225f;
        public void Start()
        {
            StartCoroutine(RRRRRRR());
        }

        public IEnumerator RRRRRRR() 
        {
        for (float i = 0; i < SporeAmount; i++)
        {
            this.gameObject.GetComponent<LimbBehaviour>().SkinMaterialHandler.AcidProgress += 0.0025f;
            yield return new WaitForSeconds(0.005f);
        }
        }

    }
    public class machinedie : MonoBehaviour
    {
        public void Start()
        {
            this.gameObject.GetComponent<DamagableMachineryBehaviour>().Break(new Vector2(2f, 2f));
        }
    }
    public class dfd : MonoBehaviour
    {
        public GameObject guh;
        public float SporeAmount = 225f;

        public void Start()
        {
            StartCoroutine(RRRRRRR());
        }

        public IEnumerator RRRRRRR() 
        {
        for (float i = 0; i < SporeAmount; i++)
        {
            this.gameObject.transform.localScale *= 1.0025f;
            yield return new WaitForSeconds(0.005f);
        }
        }

        public void Update()
        {
            this.transform.position = guh.transform.position;
            this.transform.rotation = guh.transform.rotation;
        }
    
}
    public class Halt : MonoBehaviour
    {
        public AudioClip Slow = ModAPI.LoadSound("Halt.wav");
        AudioSource auds;
        
        public void Start()
        {
            GameObject audsGO = new GameObject();
            audsGO.transform.SetParent(gameObject.transform, false);
            auds = audsGO.AddComponent<AudioSource>();
            auds.spatialBlend = 1;
            GameObject.FindObjectOfType<Global>().AddAudioSource(auds, false);
            auds.gameObject.AddComponent<AudioDistortionFilter>().distortionLevel = 0.77f;
            auds.outputAudioMixerGroup = GameObject.FindObjectOfType<Global>().SoundEffects;
            auds.volume = 1;
        }
        public void Use()
        {
            ModAPI.CreateParticleEffect("HugeZap", this.transform.position);
            auds.PlayOneShot(Slow);
            foreach (var item in GameObject.FindObjectsOfType<PhysicalBehaviour>())
                    {
            if (!item.gameObject.GetComponent<Undraggable>() && !item.gameObject.GetComponent<MapLightBehaviour>())
            {
               item.gameObject.GetComponent<Rigidbody2D>().velocity = new Vector2(0f, 0f);
            }
            }
        }
    }
    public class Speed : MonoBehaviour
    {
        public AudioClip Fast = ModAPI.LoadSound("Speed.wav");
        AudioSource auds;
        
        public void Start()
        {
            GameObject audsGO = new GameObject();
            audsGO.transform.SetParent(gameObject.transform, false);
            auds = audsGO.AddComponent<AudioSource>();
            auds.spatialBlend = 1;
            GameObject.FindObjectOfType<Global>().AddAudioSource(auds, false);
            auds.gameObject.AddComponent<AudioDistortionFilter>().distortionLevel = 0.77f;
            auds.outputAudioMixerGroup = GameObject.FindObjectOfType<Global>().SoundEffects;
            auds.volume = 1;
        }
        public void Use()
        {
            ModAPI.CreateParticleEffect("HugeZap", this.transform.position);
            auds.PlayOneShot(Fast);
            foreach (var item in GameObject.FindObjectsOfType<PhysicalBehaviour>())
                    {
            if (!item.gameObject.GetComponent<Undraggable>() && !item.gameObject.GetComponent<MapLightBehaviour>())
            {
               item.gameObject.GetComponent<Rigidbody2D>().velocity *= 5f;
            }
            }
        }
    }
    public class Puzzlr : MonoBehaviour
    {
        public int SporeAmount = 2;
        public bool AutoDetonate = false;
        public AudioClip Spread = ModAPI.LoadSound("Spread.wav");
        AudioSource auds;

        public void Start()
        {
            GameObject audsGO = new GameObject();
            audsGO.transform.SetParent(gameObject.transform, false);
            auds = audsGO.AddComponent<AudioSource>();
            auds.spatialBlend = 1;
            GameObject.FindObjectOfType<Global>().AddAudioSource(auds, false);
            auds.gameObject.AddComponent<AudioDistortionFilter>().distortionLevel = 0.77f;
            auds.outputAudioMixerGroup = GameObject.FindObjectOfType<Global>().SoundEffects;
            auds.volume = 1;
            //auds.PlayOneShot(Spread);
              Explode();
        }

        public void Explode()
        {
            for (int i = 0; i < SporeAmount; i++)
        {
           GameObject spore = GameObject.Instantiate(ModAPI.FindSpawnable("puzzlrpiece").Prefab);
                        CatalogBehaviour.PerformMod(ModAPI.FindSpawnable("puzzlrpiece"), spore);
                        spore.transform.position = this.transform.position;
                        Vector3 eulerRotation = new Vector3(Random.value, Random.value, Random.value);
                        Quaternion quaternionRotation = Quaternion.Euler(eulerRotation);
                        spore.transform.rotation = quaternionRotation;
                        spore.GetComponent<Rigidbody2D>().angularVelocity = Random.value * 5f;
                        spore.GetComponent<Rigidbody2D>().velocity = new Vector2(Random.value * 5f, Random.value * 5f); 
                        GameObject spore2 = GameObject.Instantiate(ModAPI.FindSpawnable("puzzlrpiece").Prefab);
                        CatalogBehaviour.PerformMod(ModAPI.FindSpawnable("puzzlrpiece"), spore2);
                        spore2.transform.position = this.transform.position;
                        Vector3 eulerRotation2 = new Vector3(-Random.value, -Random.value, -Random.value);
                        Quaternion quaternionRotation2 = Quaternion.Euler(eulerRotation2);
                        spore2.transform.rotation = quaternionRotation2;
                        spore2.GetComponent<Rigidbody2D>().angularVelocity = -Random.value * 5f;
                        spore2.GetComponent<Rigidbody2D>().velocity = new Vector2(-Random.value * 5f, -Random.value * 5f); 
                        var e = ModAPI.CreateParticleEffect("Vapor", spore.transform.position);
                e.GetComponent<ParticleSystem>().startColor = new Color(1f, 1f, 1f);
                var f = ModAPI.CreateParticleEffect("Vapor", spore2.transform.position);
                f.GetComponent<ParticleSystem>().startColor = new Color(1f, 1f, 1f);
        }    
        Destroy(this.gameObject);
        }
    }
    public class puzzlrpiece : MonoBehaviour
    {

        public void OnTriggerEnter2D(Collider2D other)
        {
            if (other.gameObject.GetComponent<PhysicalBehaviour>())
            {
                if (other.gameObject.layer == 9)
                {
                    if (!other.gameObject.GetComponent<puzzlrpiece>())
                    {
                    other.gameObject.AddComponent<Puzzlr>();
                    other.gameObject.GetComponent<Puzzlr>().AutoDetonate = true;
                    Destroy(this.gameObject);
                    }
                }
                else
                {
                    Destroy(this.gameObject);
                }
            }
            else
            {
                Destroy(this.gameObject);
            }
        }
    }
    public class q : MonoBehaviour
    {

    }
    public class Antipode : MonoBehaviour
    {
        public AudioClip Rewind = ModAPI.LoadSound("Rewind.wav");
        AudioSource auds;
        public bool Enabled = false;
        public GameObject arm2;
        public GameObject arm1;
        
        public void Start()
        {
            GameObject audsGO = new GameObject();
            audsGO.transform.SetParent(gameObject.transform, false);
            auds = audsGO.AddComponent<AudioSource>();
            auds.spatialBlend = 1;
            GameObject.FindObjectOfType<Global>().AddAudioSource(auds, false);
            auds.gameObject.AddComponent<AudioDistortionFilter>().distortionLevel = 0.77f;
            auds.outputAudioMixerGroup = GameObject.FindObjectOfType<Global>().SoundEffects;
            auds.volume = 1;
        }

        public void Update()
        {
            if (!Enabled)
            {
                StartCoroutine(RRRRRRR());
            }
        }

        public IEnumerator RRRRRRR() 
        {
            ModAPI.CreateParticleEffect("Flash", this.transform.position);
            this.Enabled = true;
            foreach (var item in GameObject.FindObjectsOfType<PhysicalBehaviour>())
                    {
            if (item.gameObject.GetComponent<AntipodeTime>())
            {
                Destroy(item.gameObject.GetComponent<AntipodeTime>());
            }
            if (!item.gameObject.GetComponent<Undraggable>() && !item.gameObject.GetComponent<MapLightBehaviour>() && !item.gameObject.GetComponent<q>())
            {
                item.gameObject.AddComponent<AntipodeTime>();
            }
                    }
                                yield return new WaitForSeconds(7f);
                    this.Enabled = false;
        }

        public void Use()
        {
            auds.PlayOneShot(Rewind);
            foreach (var item in GameObject.FindObjectsOfType<PhysicalBehaviour>())
                    {
            if (item.gameObject.GetComponent<AntipodeTime>())
            {
                item.gameObject.GetComponent<AntipodeTime>().DoReverse = true;
            }
                    }
        }
    }
    public class AntipodeTime : MonoBehaviour
    {
        public Vector2 spot;
        public Vector3 eulerRotation;
        public Vector2 velocity;
        float speed = 40f;
        public bool DoReverse = false;
        
        public void Start()
        {
            this.spot = this.gameObject.transform.position;
            this.velocity = this.gameObject.GetComponent<Rigidbody2D>().velocity;
            this.eulerRotation = this.transform.rotation.eulerAngles;
            Quaternion quaternionRotation = Quaternion.Euler(eulerRotation);
        }

        public void Update()
        {
            float spotx = this.spot.x;
            float tx = this.transform.position.x;
            float spoty = this.spot.y;
            float ty = this.transform.position.y;
            if (DoReverse)
            {
                Quaternion quaternionRotation = Quaternion.Euler(eulerRotation);
                this.transform.rotation = quaternionRotation;
                this.gameObject.GetComponent<Rigidbody2D>().velocity = new Vector2(0f, 0f);
            float step = speed * Time.deltaTime;
            this.gameObject.layer = 0;
            this.transform.position = Vector2.MoveTowards(this.transform.position, spot, step);
            if (tx == spotx)
            {
                if (ty == spoty)
            {
                this.gameObject.layer = 9;
                this.DoReverse = false;
            }
            else
            {
                this.transform.position = spot;
                this.gameObject.layer = 9;
                this.DoReverse = false;
            }
            }
            else
            {
                if (ty == spoty)
            {
                if (tx == spotx)
            {
                this.gameObject.layer = 9;
                this.DoReverse = false;
            }
            else
            {
                this.transform.position = spot;
                this.gameObject.layer = 9;
                this.DoReverse = false;
            }
            }
            }
            }
        }
    }
    public class Reversion : MonoBehaviour
    {
        public AudioClip Rewind = ModAPI.LoadSound("Rewind.wav");
        public AudioClip Save = ModAPI.LoadSound("Save.wav");
        AudioSource auds;
        public bool Enabled = false;
        public GameObject arm2;
        public GameObject arm1;
        
        public void Start()
        {
            GameObject audsGO = new GameObject();
            audsGO.transform.SetParent(gameObject.transform, false);
            auds = audsGO.AddComponent<AudioSource>();
            auds.spatialBlend = 1;
            GameObject.FindObjectOfType<Global>().AddAudioSource(auds, false);
            auds.gameObject.AddComponent<AudioDistortionFilter>().distortionLevel = 0.77f;
            auds.outputAudioMixerGroup = GameObject.FindObjectOfType<Global>().SoundEffects;
            auds.volume = 1;
            this.arm1.gameObject.AddComponent<UseEventTrigger>().Action = () =>
                {
                    ModAPI.CreateParticleEffect("HugeZap", this.transform.position);
            auds.PlayOneShot(Save);
            foreach (var item in GameObject.FindObjectsOfType<PhysicalBehaviour>())
                    {
            if (!item.gameObject.GetComponent<Undraggable>() && !item.gameObject.GetComponent<MapLightBehaviour>() && !item.gameObject.GetComponent<q>())
            {
                if (item.gameObject.GetComponent<ReverseTime>())
                {
                    Destroy(item.gameObject.GetComponent<ReverseTime>());
                }
               item.gameObject.AddComponent<ReverseTime>();
            }
            }
                };
            this.arm2.gameObject.AddComponent<UseEventTrigger>().Action = () =>
                {
                    ModAPI.CreateParticleEffect("HugeZap", arm2.gameObject.transform.position);
                    auds.PlayOneShot(Rewind);
                foreach (var item in GameObject.FindObjectsOfType<PhysicalBehaviour>())
                    {
            if (!item.gameObject.GetComponent<Undraggable>() && !item.gameObject.GetComponent<MapLightBehaviour>() && !item.gameObject.GetComponent<q>())
            {
               item.gameObject.GetComponent<ReverseTime>().DoReverse = true;
            }
            }
                };
        }
    }
    public class ReverseTime : MonoBehaviour
    {
        public Vector2 spot;
        public Vector3 eulerRotation;
        public Vector2 velocity;
        float speed = 40f;
        public bool DoReverse = false;
        
        public void Start()
        {
            this.spot = this.gameObject.transform.position;
            this.velocity = this.gameObject.GetComponent<Rigidbody2D>().velocity;
            this.eulerRotation = this.transform.rotation.eulerAngles;
            Quaternion quaternionRotation = Quaternion.Euler(eulerRotation);
        }

        public void Update()
        {
            float spotx = this.spot.x;
            float tx = this.transform.position.x;
            float spoty = this.spot.y;
            float ty = this.transform.position.y;
            if (DoReverse)
            {
                Quaternion quaternionRotation = Quaternion.Euler(eulerRotation);
                this.transform.rotation = quaternionRotation;
                this.gameObject.GetComponent<Rigidbody2D>().velocity = new Vector2(0f, 0f);
            float step = speed * Time.deltaTime;
            this.gameObject.layer = 0;
            this.transform.position = Vector2.MoveTowards(this.transform.position, spot, step);
            if (tx == spotx)
            {
                if (ty == spoty)
            {
                this.gameObject.layer = 9;
                this.DoReverse = false;
            }
            else
            {
                this.transform.position = spot;
                this.gameObject.layer = 9;
                this.DoReverse = false;
            }
            }
            else
            {
                if (ty == spoty)
            {
                if (tx == spotx)
            {
                this.gameObject.layer = 9;
                this.DoReverse = false;
            }
            else
            {
                this.transform.position = spot;
                this.gameObject.layer = 9;
                this.DoReverse = false;
            }
            }
            }
            }
        }
    }
    public class Flow : MonoBehaviour
    {
        public AudioClip Active = ModAPI.LoadSound("Active.wav");
        public AudioClip Deactive = ModAPI.LoadSound("Deactive.wav");
        AudioSource auds;
        public bool Enabled = false;
        public GameObject dingy;
        public LightSprite ScreenLight;
        
        public void Start()
        {
            ScreenLight = ModAPI.CreateLight(transform, new Color(0f, 1f, 0.4f, 1));
        ScreenLight.Brightness = 0f;
        ScreenLight.Radius = 9999999f;
        ScreenLight.transform.SetParent(this.gameObject.transform);
            GameObject audsGO = new GameObject();
            audsGO.transform.SetParent(gameObject.transform, false);
            auds = audsGO.AddComponent<AudioSource>();
            auds.spatialBlend = 1;
            GameObject.FindObjectOfType<Global>().AddAudioSource(auds, false);
            auds.gameObject.AddComponent<AudioDistortionFilter>().distortionLevel = 0.77f;
            auds.outputAudioMixerGroup = GameObject.FindObjectOfType<Global>().SoundEffects;
            auds.volume = 1;
        }
        public void Use()
        {
            if (!Enabled)
            {
                ScreenLight.Brightness = -5000f;
                StartCoroutine(RRRRRRR());
            ModAPI.CreateParticleEffect("HugeZap", this.transform.position);
            auds.PlayOneShot(Active);
            foreach (var item in GameObject.FindObjectsOfType<PhysicalBehaviour>())
                    {
            if (!item.gameObject.GetComponent<Undraggable>() && !item.gameObject.GetComponent<MapLightBehaviour>() && !item.gameObject.GetComponent<q>())
            {
               item.gameObject.AddComponent<FlowTime>();
            }
            }
            }
        }
        public IEnumerator RRRRRRR() 
        {
            this.Enabled = true;
            foreach (var limbs in this.gameObject.transform.root.gameObject.GetComponent<PersonBehaviour>().Limbs)
                        {
                            limbs.gameObject.layer = 10;
                        }
                        if (dingy != null)
                        {
            this.dingy.GetComponent<SpriteRenderer>().color = Color.red;
                        }
            yield return new WaitForSeconds(7f);
            auds.PlayOneShot(Deactive);
            ModAPI.CreateParticleEffect("HugeZap", this.transform.position);
            ScreenLight.Brightness = 0f;
            foreach (var limbs in this.gameObject.transform.root.gameObject.GetComponent<PersonBehaviour>().Limbs)
                        {
                            limbs.gameObject.layer = 9;
                        }
                        if (dingy != null)
                        {
            this.dingy.GetComponent<SpriteRenderer>().color = Color.clear;
                        }
            this.Enabled = false;
        }
    }
    public class FlowTime : MonoBehaviour
    {
        public Vector2 spot;
        public Vector2 rotation;
        public Vector2 velocity;
        
        public void Start()
        {
            this.spot = this.gameObject.transform.position;

            this.velocity = this.gameObject.GetComponent<Rigidbody2D>().velocity;
            var trailrenderer = this.gameObject.AddComponent<TrailRenderer>();
                            trailrenderer.startWidth = 0.1f;
                            trailrenderer.endWidth = 0.05f;
                            trailrenderer.time = 10f;
                            trailrenderer.startColor = Color.clear;
                            trailrenderer.endColor = Color.clear;
                            trailrenderer.material = ModAPI.FindMaterial("VeryBright");
                            trailrenderer.sortingOrder = this.gameObject.GetComponent<SpriteRenderer>().sortingOrder = 1;
            StartCoroutine(RRRRRRR());
        }

        public IEnumerator RRRRRRR() 
        {
            Vector3 eulerRotation = this.transform.rotation.eulerAngles;
            Quaternion quaternionRotation = Quaternion.Euler(eulerRotation);
            this.gameObject.GetComponent<TrailRenderer>().startColor = new Color32(100, 0, 0, 100);
                this.gameObject.GetComponent<TrailRenderer>().endColor = Color.clear;
                yield return new WaitForSeconds(7f);
                this.gameObject.transform.position = this.spot;
                this.gameObject.GetComponent<Rigidbody2D>().velocity = this.velocity;
            this.gameObject.GetComponent<TrailRenderer>().startColor = Color.clear;
                this.gameObject.GetComponent<TrailRenderer>().endColor = Color.clear;
                this.transform.rotation = quaternionRotation;
                Destroy(this.gameObject.GetComponent<FlowTime>());
                Destroy(this.gameObject.GetComponent<TrailRenderer>());
        }
    }
    public class Aureus : MonoBehaviour
    {
        public AudioClip TimeActive = ModAPI.LoadSound("TimeActive.wav");
        public AudioClip TimeExit = ModAPI.LoadSound("TimeExit.wav");
        AudioSource auds;
        public bool Enabled = false;
        public GameObject dingy;
        public LightSprite ScreenLight;
        
        public void Start()
        {
            ScreenLight = ModAPI.CreateLight(transform, new Color(0f, 1f, 0f, 1));
        ScreenLight.Brightness = 0f;
        ScreenLight.Radius = 9999999f;
        ScreenLight.transform.SetParent(this.gameObject.transform);
            GameObject audsGO = new GameObject();
            audsGO.transform.SetParent(gameObject.transform, false);
            auds = audsGO.AddComponent<AudioSource>();
            auds.spatialBlend = 1;
            GameObject.FindObjectOfType<Global>().AddAudioSource(auds, false);
            auds.gameObject.AddComponent<AudioDistortionFilter>().distortionLevel = 0.77f;
            auds.outputAudioMixerGroup = GameObject.FindObjectOfType<Global>().SoundEffects;
            auds.volume = 1;
        }
        public void Use()
        {
            if (!Enabled)
            {
                ScreenLight.Brightness = -5000f;
                StartCoroutine(RRRRRRR());
            ModAPI.CreateParticleEffect("HugeZap", this.transform.position);
            auds.PlayOneShot(TimeActive);
            foreach (var item in GameObject.FindObjectsOfType<PhysicalBehaviour>())
                    {
            if (!item.gameObject.GetComponent<Undraggable>() && !item.gameObject.GetComponent<MapLightBehaviour>() && !item.gameObject.GetComponent<q>())
            {
               item.gameObject.AddComponent<AureusTime>();
            }
            }
            }
        }
        public IEnumerator RRRRRRR() 
        {
            this.Enabled = true;
            if (dingy != null)
                        {
            this.dingy.GetComponent<SpriteRenderer>().color = Color.magenta;
                        }
            yield return new WaitForSeconds(7f);
            auds.PlayOneShot(TimeExit);
            yield return new WaitForSeconds(3f);
            ModAPI.CreateParticleEffect("HugeZap", this.transform.position);
            ScreenLight.Brightness = 0f;
            if (dingy != null)
                        {
            this.dingy.GetComponent<SpriteRenderer>().color = Color.clear;
                        }
            this.Enabled = false;
        }
    }
    public class AureusTime : MonoBehaviour
    {
        public Vector2 velocity;
        
        public void Start()
        {
            this.velocity = this.gameObject.GetComponent<Rigidbody2D>().velocity;
            var trailrenderer = this.gameObject.AddComponent<TrailRenderer>();
                            trailrenderer.startWidth = 0.2f;
                            trailrenderer.endWidth = 0.1f;
                            trailrenderer.time = 10f;
                            trailrenderer.startColor = Color.clear;
                            trailrenderer.endColor = Color.clear;
                            trailrenderer.material = ModAPI.FindMaterial("VeryBright");
                            trailrenderer.sortingOrder = this.gameObject.GetComponent<SpriteRenderer>().sortingOrder = 1;
            StartCoroutine(RRRRRRR());
        }

        public IEnumerator RRRRRRR() 
        {
            this.gameObject.GetComponent<PhysicalBehaviour>().rigidbody.gravityScale = 0f;
            this.gameObject.GetComponent<Rigidbody2D>().velocity = this.velocity * 0.05f;
            this.gameObject.GetComponent<TrailRenderer>().startColor = new Color32(50, 0, 100, 100);
                this.gameObject.GetComponent<TrailRenderer>().endColor = Color.clear;
                yield return new WaitForSeconds(10f);
                this.gameObject.GetComponent<PhysicalBehaviour>().rigidbody.gravityScale = 1f;
                this.gameObject.GetComponent<Rigidbody2D>().velocity /= 0.05f;
            this.gameObject.GetComponent<TrailRenderer>().startColor = Color.clear;
                this.gameObject.GetComponent<TrailRenderer>().endColor = Color.clear;
                Destroy(this.gameObject.GetComponent<AureusTime>());
                Destroy(this.gameObject.GetComponent<TrailRenderer>());
        }
    }
}